/* configuration.c */

/*****************************************************************************

05-May-94	Processing for nique key search bulkloadtailor configuration
		items added.

11-May-94	Certain str2AttrV calls replaced with str_at2AttrV() if there
		is any potential for leading {T.61} headers.

17-May-94	DN Integrity check option added.
		The bulk user over ride option was added.

*****************************************************************************/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <sys/time.h>

#include <isode/quipu/name.h>

#include "bulkman.h"
#include "bulkloadglobal.h"
#include "bulkloadattrnames.h"
#include "configuration.h"
#include "processandupdate.h"
#include "util.h"

extern	char * processFileTokens[] ;

/*
 * The configuration table
 */
 
struct	bulkLoadConfigStruct	bulkLoadConfig ;
struct	managementConfigStruct	managementConfig ;


char *	configTitleTokens[ NUMCONFIGTITLETYPES ] = { 

			   /* Gender tokens.. */
			   "Male",
			   "Female",
			   "Human",
			   "NonHuman"
			 } ;
			 
char *	configErrorTokens[ NUMCONFIGERRORTYPES ] = { 

			   /* error processing tokens.. */

			   "AddValueThatAlreadyExists",
			   "AddAttributeThatAlreadyExists",
			   "AddValueWhenNotMasterSource",
			   "AddAttributeWhenNotMasterSource",
			   "DeleteValueWhenNotMasterSource",
			   "DeleteAttributeWhenNotMasterSource",
			   "DeleteValueThatDoesNotExist",
			   "DeleteAttributeThatDoesNotExist",
			   "CreateEntryWhenNotCreateSource",
			   "DeleteEntryWhenNotDeleteSource"
			 } ;

char *	configErrorDisplayTokens[ NUMCONFIGERRORTYPES ] = {

			   /* error processing display tokens.. */

			   "Add value that already exists   ",
			   "Add attribute that already exists",
			   "Add value when not master source",
			   "Add attribute when not master source",
			   "Delete value when not master source",
			   "Delete attribute when not master source",
			   "Delete value that does not exist",
			   "Delete attribute that does not exist",
			   "Create entry when not create source",
			   "Delete entry when not delete source"
			 } ;

/* Note: procedure uses the parameter without taking a copy */

struct autoInsertObjClsListNode *
appendNewAutoInsertObjClsListNode( baseAutoInsertObjClsListNodepp, autoInsertObjClsAttrV )
struct autoInsertObjClsListNode ** baseAutoInsertObjClsListNodepp ;
AttributeValue	autoInsertObjClsAttrV ;
{
struct autoInsertObjClsListNode * retNodep = NULLAUTOINSERTOBJCLSLIST ;
struct autoInsertObjClsListNode * currAutoInsertObjClsListNodep = *baseAutoInsertObjClsListNodepp,
				* lastAutoInsertObjClsListNodep = NULLAUTOINSERTOBJCLSLIST ;

	if( autoInsertObjClsAttrV == NULLAttrV )
	    return( retNodep ) ;
		
	if( (retNodep = (struct autoInsertObjClsListNode *)malloc( sizeof( struct autoInsertObjClsListNode ) )) != NULLAUTOINSERTOBJCLSLIST )
	{
	    retNodep -> autoInsertObjClsAttrV 	      = autoInsertObjClsAttrV ;
	    retNodep -> nextAutoInsertObjClsListNodep = NULLAUTOINSERTOBJCLSLIST ;

	    /* Find the last list node that is already held.. */
	    while( currAutoInsertObjClsListNodep != NULLAUTOINSERTOBJCLSLIST )
	    {
	    	lastAutoInsertObjClsListNodep = currAutoInsertObjClsListNodep ; /* Eventually ! */
		currAutoInsertObjClsListNodep = currAutoInsertObjClsListNodep -> nextAutoInsertObjClsListNodep ;
	    }

	    /* Link in the new node.. */
	    if( lastAutoInsertObjClsListNodep == NULLAUTOINSERTOBJCLSLIST )
		*baseAutoInsertObjClsListNodepp = retNodep ;
	    else
		lastAutoInsertObjClsListNodep -> nextAutoInsertObjClsListNodep = retNodep ;
	}
	
	return( retNodep ) ;
}

/* Note: procedure uses the parameter without taking a copy */

struct autoInsertNode *
appendNewAutoInsertNode( baseAutoInsertNodepp, autoInsertOnAttrT )
struct autoInsertNode ** baseAutoInsertNodepp ;
AttributeType	autoInsertOnAttrT ;
{
struct autoInsertNode * retNodep = NULLAUTOINSERTNODE ;
struct autoInsertNode * currAutoInsertNodep = *baseAutoInsertNodepp, * lastAutoInsertNodep = NULLAUTOINSERTNODE ;

	if( autoInsertOnAttrT == NULLAttrT )
	    return( retNodep ) ;

	if( (retNodep = (struct autoInsertNode *)malloc( sizeof( struct autoInsertNode ) )) != NULLAUTOINSERTNODE )
	{
	    retNodep -> autoInsertOnAttrT 	= autoInsertOnAttrT ;
	    retNodep -> autoInsertOnAttrV 	= NULLAttrV ;
	    retNodep -> autoInsertObjClsListp 	= NULLAUTOINSERTOBJCLSLIST ;
	    retNodep -> nextAutoInsertNodep 	= NULLAUTOINSERTNODE ;

	    /* Find the last node already held.. */
	    while( currAutoInsertNodep != NULLAUTOINSERTNODE )
	    {
		lastAutoInsertNodep = currAutoInsertNodep ; /* Eventually ! */
		currAutoInsertNodep = currAutoInsertNodep -> nextAutoInsertNodep ;
	    }

	    /* Link in the new node.. */
	    if( lastAutoInsertNodep == NULLAUTOINSERTNODE )
		*baseAutoInsertNodepp = retNodep ;
	    else
		lastAutoInsertNodep -> nextAutoInsertNodep = retNodep ;
	}

	return( retNodep ) ;
}

struct autoInsertNode *
findLastAutoInsertNode( baseAutoInsertNodep )
struct autoInsertNode * baseAutoInsertNodep ;
{
struct autoInsertNode * currAutoInsertNodep = baseAutoInsertNodep, *lastAutoInsertNodep = NULLAUTOINSERTNODE ;

	while( currAutoInsertNodep != NULLAUTOINSERTNODE ) {
	    lastAutoInsertNodep = currAutoInsertNodep ; /* Eventually ! */
	    currAutoInsertNodep = currAutoInsertNodep -> nextAutoInsertNodep ;
	}

	return( lastAutoInsertNodep ) ;
}

void
freeAutoInsertList( baseAutoInsertNodep )
struct autoInsertNode * baseAutoInsertNodep ;
{
struct autoInsertNode * currAutoInsertNodep = baseAutoInsertNodep, * prevAutoInsertNodep ;
struct autoInsertObjClsListNode * currAutoInsertObjClsListNodep, * prevAutoInsertObjClsListNodep ;

	while( currAutoInsertNodep != NULLAUTOINSERTNODE )
	{
	    if( currAutoInsertNodep -> autoInsertOnAttrT != NULLAttrT )
	    	AttrT_free( currAutoInsertNodep -> autoInsertOnAttrT ) ;

	    if( currAutoInsertNodep -> autoInsertOnAttrV != NULLAttrV )
	    	AttrV_free( currAutoInsertNodep -> autoInsertOnAttrV ) ;

	    currAutoInsertObjClsListNodep = currAutoInsertNodep -> autoInsertObjClsListp ;

	    while( currAutoInsertObjClsListNodep != NULLAUTOINSERTOBJCLSLIST )
	    {
		if( currAutoInsertObjClsListNodep -> autoInsertObjClsAttrV != NULLAttrV )
		    AttrV_free( currAutoInsertObjClsListNodep -> autoInsertObjClsAttrV ) ;

	    	prevAutoInsertObjClsListNodep = currAutoInsertObjClsListNodep ;
	    	currAutoInsertObjClsListNodep = currAutoInsertObjClsListNodep -> nextAutoInsertObjClsListNodep ;
		(void)free( (char *)prevAutoInsertObjClsListNodep ) ; /* Return the node itself */
	    }

	    prevAutoInsertNodep = currAutoInsertNodep ;
	    currAutoInsertNodep = currAutoInsertNodep -> nextAutoInsertNodep ;
	    (void)free( (char *)prevAutoInsertNodep ) ; /* Return the node itself */
	}

	return ;
}


/* Note: procedure uses the parameter without taking a copy */

struct uniqueKeyNode *
appendNewUniqueKeyNode( baseUniqueKeyNodepp, uniqueKeyAttrT )
struct uniqueKeyNode ** baseUniqueKeyNodepp ;
AttributeType	uniqueKeyAttrT ;
{
struct uniqueKeyNode * retNodep = NULLUNIQUEKEYNODE ;
struct uniqueKeyNode * currUniqueKeyNodep = *baseUniqueKeyNodepp, * lastUniqueKeyNodep = NULLUNIQUEKEYNODE ;

	if( uniqueKeyAttrT == NULLAttrT )
	    return( retNodep ) ;

	if( (retNodep = (struct uniqueKeyNode *)malloc( sizeof( struct uniqueKeyNode ) )) != NULLUNIQUEKEYNODE )
	{
	    retNodep -> uniqueKeyAttrT		= uniqueKeyAttrT ;
	    retNodep -> nextUniqueKeyNodep 	= NULLUNIQUEKEYNODE ;

	    /* Find the last node already held.. */
	    while( currUniqueKeyNodep != NULLUNIQUEKEYNODE )
	    {
		lastUniqueKeyNodep = currUniqueKeyNodep ; /* Eventually ! */
		currUniqueKeyNodep = currUniqueKeyNodep -> nextUniqueKeyNodep ;
	    }

	    /* Link in the new node.. */
	    if( lastUniqueKeyNodep == NULLUNIQUEKEYNODE )
		*baseUniqueKeyNodepp = retNodep ;
	    else
		lastUniqueKeyNodep -> nextUniqueKeyNodep = retNodep ;
	}

	return( retNodep ) ;
}


void
freeUniqueKeyList( baseUniqueKeyNodep )
struct  uniqueKeyNode * baseUniqueKeyNodep ;
{
struct  uniqueKeyNode * currUniqueKeyNodep = baseUniqueKeyNodep,
		      * prevUniqueKeyNodep = NULLUNIQUEKEYNODE ;

	while( currUniqueKeyNodep != NULLUNIQUEKEYNODE ) {

	    if( currUniqueKeyNodep->uniqueKeyAttrT != NULLAttrT )
		AttrT_free( currUniqueKeyNodep->uniqueKeyAttrT ) ;

	    prevUniqueKeyNodep = currUniqueKeyNodep ;
	    currUniqueKeyNodep = currUniqueKeyNodep -> nextUniqueKeyNodep ;
	    (void)free( (char*)prevUniqueKeyNodep ) ; /* Return the node itself */
	}

	return ;
}

void
freeCheckDNAttrTList( baseCheckDNAttrTNodep )
struct  checkDNAttrTNode * baseCheckDNAttrTNodep ;
{
struct  checkDNAttrTNode * currCheckDNAttrTNodep = baseCheckDNAttrTNodep,
			 * prevCheckDNAttrTNodep = NULLCHKDNNODE ;

	while( currCheckDNAttrTNodep != NULLCHKDNNODE ) {

	    if( currCheckDNAttrTNodep->checkDNAttrT != NULLAttrT )
		AttrT_free( currCheckDNAttrTNodep->checkDNAttrT ) ;

	    prevCheckDNAttrTNodep = currCheckDNAttrTNodep ;
	    currCheckDNAttrTNodep = currCheckDNAttrTNodep -> nextCheckDNAttrTNode ;
	    (void)free( (char*)prevCheckDNAttrTNodep ) ; /* Return the node itself */
	}

	return ;
}

void
initSourceReportParams( firstInitialisation )
int	firstInitialisation ;
{
	managementConfig.returnToMenu = FALSE ;

	if( firstInitialisation == TRUE )
	    managementConfig.sourceReportSubTreeParentDNcp = NULLCP ;
	else if( managementConfig.sourceReportSubTreeParentDNcp != NULLCP )
	{
	    (void)free( managementConfig.sourceReportSubTreeParentDNcp ) ;
	    managementConfig.sourceReportSubTreeParentDNcp = NULLCP ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.sourceReportLevels = 1 ;	

	if( firstInitialisation == TRUE )
	    managementConfig.sourceReportSubTreeParentDN = NULLDN ;
	else if( managementConfig.sourceReportSubTreeParentDN != NULLDN )
	{
	    dn_free( managementConfig.sourceReportSubTreeParentDN ) ;
	    managementConfig.sourceReportSubTreeParentDN = NULLDN ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.sourceReportFileNamecp = NULLCP ;
	else if( managementConfig.sourceReportFileNamecp != NULLCP )
	{
	    (void)free( managementConfig.sourceReportFileNamecp ) ;
	    managementConfig.sourceReportFileNamecp = NULLCP ;
	}

	return ;
}

void
initExpiredEntriesParams( firstInitialisation )
int	firstInitialisation ;
{
	managementConfig.returnToMenu = FALSE ;

	if( firstInitialisation == TRUE )
	    managementConfig.expiredEntriesSubTreeParentDNcp = NULLCP ;
	else if( managementConfig.expiredEntriesSubTreeParentDNcp != NULLCP )
	{
	    (void)free( managementConfig.expiredEntriesSubTreeParentDNcp ) ;
	    managementConfig.expiredEntriesSubTreeParentDNcp = NULLCP ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.expiredEntriesSubTreeParentDN = NULLDN ;
	else if( managementConfig.expiredEntriesSubTreeParentDN != NULLDN )
	{
	    dn_free( managementConfig.expiredEntriesSubTreeParentDN ) ;
	    managementConfig.expiredEntriesSubTreeParentDN = NULLDN ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.expiredEntriesLogFileNamecp = NULLCP ;
	else if( managementConfig.expiredEntriesLogFileNamecp != NULLCP )
	{
	    (void)free( managementConfig.expiredEntriesLogFileNamecp ) ;
	    managementConfig.expiredEntriesLogFileNamecp = NULLCP ;
	}

	if( firstInitialisation == TRUE )
	{
	    managementConfig.expiredEntriesUTCtimecp = NULLCP ;
	}
	else 
	{
	    if( managementConfig.expiredEntriesUTCtimecp != NULLCP )
	    {
	    	(void)free( managementConfig.expiredEntriesUTCtimecp ) ;
		managementConfig.expiredEntriesUTCtimecp = NULLCP ;
	    }
	}

	return ;
}

void
initDumpSubtreeParams( firstInitialisation )
int	firstInitialisation ;
{
	managementConfig.returnToMenu = FALSE ;

	if( firstInitialisation == TRUE )
	    managementConfig.dumpSubtreeSubTreeParentDNcp = NULLCP ;
	else if( managementConfig.dumpSubtreeSubTreeParentDNcp != NULLCP )
	{
	    (void)free( managementConfig.dumpSubtreeSubTreeParentDNcp ) ;
	    managementConfig.dumpSubtreeSubTreeParentDNcp = NULLCP ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.dumpSubtreeSubTreeParentDN = NULLDN ;
	else if( managementConfig.dumpSubtreeSubTreeParentDN != NULLDN )
	{
	    dn_free( managementConfig.dumpSubtreeSubTreeParentDN ) ;
	    managementConfig.dumpSubtreeSubTreeParentDN = NULLDN ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.dumpSubtreeFileNamecp = NULLCP ;
	else if( managementConfig.dumpSubtreeFileNamecp != NULLCP )
	{
	    (void)free( managementConfig.dumpSubtreeFileNamecp ) ;
	    managementConfig.dumpSubtreeFileNamecp = NULLCP ;
	}

	return ;
}

void
initAddValueToSubtreeParams( firstInitialisation )
int	firstInitialisation ;
{
	managementConfig.returnToMenu = FALSE ;

	if( firstInitialisation == TRUE )
	    managementConfig.addValueToSubTreeParentDNcp = NULLCP ;
	else if( managementConfig.addValueToSubTreeParentDNcp != NULLCP )
	{
	    (void)free( managementConfig.addValueToSubTreeParentDNcp ) ;
	    managementConfig.addValueToSubTreeParentDNcp = NULLCP ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.addValueToSubTreeParentDN = NULLDN ;
	else if( managementConfig.addValueToSubTreeParentDN != NULLDN )
	{
	    dn_free( managementConfig.addValueToSubTreeParentDN ) ;
	    managementConfig.addValueToSubTreeParentDN = NULLDN ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.addValueToJustLeafNodes = TRUE ;

	if( firstInitialisation == TRUE )
	    managementConfig.addValueToSubTreeAt = NULLAttrT ;
	else if( managementConfig.addValueToSubTreeAt != NULLAttrT )
	{
	    AttrT_free( managementConfig.addValueToSubTreeAt ) ;
	    managementConfig.addValueToSubTreeAt = NULLAttrT ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.addValueToSubTreeAv = NULLAttrV ;
	else if( managementConfig.addValueToSubTreeAv != NULLAttrV )
	{
	    AttrV_free( managementConfig.addValueToSubTreeAv ) ;
	    managementConfig.addValueToSubTreeAv = NULLAttrV ;
	}

	return ;
}

void
initResetValidCheckAtParams( firstInitialisation )
int	firstInitialisation ;
{
	managementConfig.returnToMenu = FALSE ;

	if( firstInitialisation == TRUE )
	    managementConfig.resetValidChkAtSubTreeParentDNcp = NULLCP ;
	else if( managementConfig.resetValidChkAtSubTreeParentDNcp != NULLCP )
	{
	    (void)free( managementConfig.resetValidChkAtSubTreeParentDNcp ) ;
	    managementConfig.resetValidChkAtSubTreeParentDNcp = NULLCP ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.resetValidChkAtSubTreeParentDN = NULLDN ;
	else if( managementConfig.resetValidChkAtSubTreeParentDN != NULLDN )
	{
	    dn_free( managementConfig.resetValidChkAtSubTreeParentDN ) ;
	    managementConfig.resetValidChkAtSubTreeParentDN = NULLDN ;
	}

	if( firstInitialisation == TRUE )
	{
	    managementConfig.resetValidChkAtLogFileNamecp = NULLCP ;
	}
	else 
	{
	    if( managementConfig.resetValidChkAtLogFileNamecp != NULLCP )
	    {
	    	(void)free( managementConfig.resetValidChkAtLogFileNamecp ) ;
		managementConfig.resetValidChkAtLogFileNamecp = NULLCP ;
	    }
	}

	if( firstInitialisation == TRUE )
	{
	    managementConfig.resetValidChkAtUTCtimecp = NULLCP ;
	}
	else 
	{
	    if( managementConfig.resetValidChkAtUTCtimecp != NULLCP )
	    {
	    	(void)free( managementConfig.resetValidChkAtUTCtimecp ) ;
		managementConfig.resetValidChkAtUTCtimecp = NULLCP ;
	    }
	}

	return ;
}

void
initSourceValidationParams( firstInitialisation )
int	firstInitialisation ;
{
	managementConfig.returnToMenu = FALSE ;

	if( firstInitialisation == TRUE )
	    managementConfig.sourceValidationInputFileNamecp = NULLCP ;
	else if( managementConfig.sourceValidationInputFileNamecp != NULLCP )
	{
	    (void)free( managementConfig.sourceValidationInputFileNamecp ) ;
	    managementConfig.sourceValidationInputFileNamecp = NULLCP ;
	}

	return ;
}

void
initCheckValidCheckAtParams( firstInitialisation )
int	firstInitialisation ;
{
	managementConfig.returnToMenu = FALSE ;

	if( firstInitialisation == TRUE )
	    managementConfig.checkValidChkAtSubTreeParentDNcp = NULLCP ;
	else if( managementConfig.checkValidChkAtSubTreeParentDNcp != NULLCP )
	{
	    (void)free( managementConfig.checkValidChkAtSubTreeParentDNcp ) ;
	    managementConfig.checkValidChkAtSubTreeParentDNcp = NULLCP ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.checkValidChkAtSubTreeParentDN = NULLDN ;
	else if( managementConfig.checkValidChkAtSubTreeParentDN != NULLDN )
	{
	    dn_free( managementConfig.checkValidChkAtSubTreeParentDN ) ;
	    managementConfig.checkValidChkAtSubTreeParentDN = NULLDN ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.checkValidChkAtLogFileNamecp = NULLCP ;
	else if( managementConfig.checkValidChkAtLogFileNamecp != NULLCP )
	{
	    (void)free( managementConfig.checkValidChkAtLogFileNamecp ) ;
	    managementConfig.checkValidChkAtLogFileNamecp = NULLCP ;
	}

	if( firstInitialisation == TRUE )
	{
	    managementConfig.checkValidChkAtUTCtimecp = NULLCP ;
	}
	else 
	{
	    if( managementConfig.checkValidChkAtUTCtimecp != NULLCP )
	    {
	    	(void)free( managementConfig.checkValidChkAtUTCtimecp ) ;
		managementConfig.checkValidChkAtUTCtimecp = NULLCP ;
	    }
	}

	return ;
}

void
initMasterUpAtforNonMasterUpAtParams( firstInitialisation )
int	firstInitialisation ;
{
	managementConfig.returnToMenu = FALSE ;

	if( firstInitialisation == TRUE )
	    managementConfig.masterUpAtToNonMasterSubTreeParentDNcp = NULLCP ;
	else if( managementConfig.masterUpAtToNonMasterSubTreeParentDNcp != NULLCP )
	{
	    (void)free( managementConfig.masterUpAtToNonMasterSubTreeParentDNcp ) ;
	    managementConfig.masterUpAtToNonMasterSubTreeParentDNcp = NULLCP ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.masterUpAtToNonMasterSubTreeParentDN = NULLDN ;
	else if( managementConfig.masterUpAtToNonMasterSubTreeParentDN != NULLDN )
	{
	    dn_free( managementConfig.masterUpAtToNonMasterSubTreeParentDN ) ;
	    managementConfig.masterUpAtToNonMasterSubTreeParentDN = NULLDN ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.masterUpAtToNonMasterLogFileNamecp = NULLCP ;
	else if( managementConfig.masterUpAtToNonMasterLogFileNamecp != NULLCP )
	{
	    (void)free( managementConfig.masterUpAtToNonMasterLogFileNamecp ) ;
	    managementConfig.masterUpAtToNonMasterLogFileNamecp = NULLCP ;
	}

	if( firstInitialisation == TRUE )
	{
	    managementConfig.masterUpAtToNonMasterMode = 'e' ;
	}

	return ;
}

void
initCheckDNParams( firstInitialisation )
int	firstInitialisation ;
{
	managementConfig.returnToMenu = FALSE ;

	if( firstInitialisation == TRUE )
	    managementConfig.checkDNSubTreeParentDNcp = NULLCP ;
	else if( managementConfig.checkDNSubTreeParentDNcp != NULLCP )
	{
	    (void)free( managementConfig.checkDNSubTreeParentDNcp ) ;
	    managementConfig.checkDNSubTreeParentDNcp = NULLCP ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.checkDNSubTreeParentDN = NULLDN ;
	else if( managementConfig.checkDNSubTreeParentDN != NULLDN )
	{
	    dn_free( managementConfig.checkDNSubTreeParentDN ) ;
	    managementConfig.checkDNSubTreeParentDN = NULLDN ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.checkDNLogFileNamecp = NULLCP ;
	else if( managementConfig.checkDNLogFileNamecp != NULLCP )
	{
	    (void)free( managementConfig.checkDNLogFileNamecp ) ;
	    managementConfig.checkDNLogFileNamecp = NULLCP ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.checkDNAttrTs = NULLCHKDNNODE ;
	else if( managementConfig.checkDNAttrTs != NULLCHKDNNODE )
	{
	    freeCheckDNAttrTList( managementConfig.checkDNAttrTs ) ;
	    managementConfig.checkDNAttrTs = NULLCHKDNNODE ;
	}

	return ;
}

void
initRoleOccXrefParams( firstInitialisation )
int	firstInitialisation ;
{
	managementConfig.returnToMenu = FALSE ;

	if( firstInitialisation == TRUE )
	    managementConfig.roleOccXrefSubTreeParentDNcp = NULLCP ;
	else if( managementConfig.roleOccXrefSubTreeParentDNcp != NULLCP )
	{
	    (void)free( managementConfig.roleOccXrefSubTreeParentDNcp ) ;
	    managementConfig.roleOccXrefSubTreeParentDNcp = NULLCP ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.roleOccXrefSubTreeParentDN = NULLDN ;
	else if( managementConfig.roleOccXrefSubTreeParentDN != NULLDN )
	{
	    dn_free( managementConfig.roleOccXrefSubTreeParentDN ) ;
	    managementConfig.roleOccXrefSubTreeParentDN = NULLDN ;
	}

	if( firstInitialisation == TRUE )
	    managementConfig.roleOccXrefLogFileNamecp = NULLCP ;
	else if( managementConfig.roleOccXrefLogFileNamecp != NULLCP )
	{
	    (void)free( managementConfig.roleOccXrefLogFileNamecp ) ;
	    managementConfig.roleOccXrefLogFileNamecp = NULLCP ;
	}

	return ;
}


void
initManagementConfigurations( firstInitialisation )
int	firstInitialisation ;
{
	if( firstInitialisation == TRUE )
	    managementConfig.defaultDNcp = NULLCP ;
	else if( managementConfig.defaultDNcp != NULLCP ) {

	    (void)free( managementConfig.defaultDNcp ) ;
	    managementConfig.defaultDNcp = NULLCP ;
	}

	managementConfig.returnToMenu = FALSE ;

	initSourceReportParams( firstInitialisation ) ;
	initExpiredEntriesParams( firstInitialisation ) ;
	initDumpSubtreeParams( firstInitialisation ) ;
	initAddValueToSubtreeParams( firstInitialisation ) ;
	initResetValidCheckAtParams( firstInitialisation ) ;
	initSourceValidationParams( firstInitialisation ) ;
	initCheckValidCheckAtParams( firstInitialisation ) ;
	initMasterUpAtforNonMasterUpAtParams( firstInitialisation ) ;
	initCheckDNParams( firstInitialisation ) ;
	initRoleOccXrefParams( firstInitialisation ) ;

	return ;
}


void
initBulkLoadConfigurations( firstInitialisation )
int	firstInitialisation ;
{
int	tokenIndex, configIndex, attrTindex ;
char *	cp ;
AttributeType	at ;


	/*
	 * COMMAND LINE configuration ITEMS 
	 */

	if( firstInitialisation == TRUE )
	{
	    bulkLoadConfig.bulkSourceTotalAccess = FALSE ;

	    bulkLoadConfig.disableBulkAttributeUsage = FALSE ;

	    bulkLoadConfig.updatesToExistingEntries  = FALSE ;

	    bulkLoadConfig.updatesToExistingEntriesIfUnique  = FALSE ;

	    bulkLoadConfig.ignoreCloseNameMatches    = FALSE ;
	}

	/*
	 * EDIT CONFIGURATION ITEMS
	 */

	if( firstInitialisation == TRUE )
	    bulkLoadConfig.autoInsertNodep = NULLAUTOINSERTNODE ;
	else {

	    freeAutoInsertList( bulkLoadConfig.autoInsertNodep ) ;
	    bulkLoadConfig.autoInsertNodep = NULLAUTOINSERTNODE ;
	}

	if( firstInitialisation == TRUE )
	    bulkLoadConfig.uniqueKeyNodep = NULLUNIQUEKEYNODE ;
	else {

	    freeUniqueKeyList( bulkLoadConfig.uniqueKeyNodep ) ;
	    bulkLoadConfig.uniqueKeyNodep = NULLUNIQUEKEYNODE ;
	}
	
	bulkLoadConfig.valueClearDownPermittedOnFirstMasterUpdate = TRUE ;
	
	bulkLoadConfig.allSourcesAreCreateSources = TRUE ;

	bulkLoadConfig.autoAddEntryToAddAttrIfExists = FALSE ;

	bulkLoadConfig.highestDataSourceSearchLevel = CONFIGHIGHESTDATASRCLEVEL ;

	bulkLoadConfig.noMasterSpecifiedSoAllSourcesAreMasters = FALSE ;

	
	if( firstInitialisation == FALSE )
	{
	    for( attrTindex = 0 ; attrTindex <= bulkLoadConfig.lastUsedAttrTIndex ; attrTindex++ )
	    {
		if( (at = bulkLoadConfig.allSourcesAreMastersForAttrT[ attrTindex ]) != NULLAttrT )
		{
		    AttrT_free( at ) ;
		    bulkLoadConfig.allSourcesAreMastersForAttrT[ attrTindex ] = NULLAttrT ;
		}
	    }
	}
	
	bulkLoadConfig.lastUsedAttrTIndex = -1 ;
	
	
	bulkLoadConfig.displayConfigAtStart = TRUE ;
	
	for( tokenIndex = 0 ; tokenIndex < NUMCONFIGERRORTYPES ; tokenIndex ++ )
	    bulkLoadConfig.configErrorProcReq[ tokenIndex ] = PROCESSTHEUPDATE ;

	for( tokenIndex = 0 ; tokenIndex < NUMCONFIGTITLETYPES ; tokenIndex ++ )
	{
	    if( firstInitialisation == FALSE )
	    {
	    	for( configIndex = 0 ; configIndex <= bulkLoadConfig.lastUsedTitlesToken[ tokenIndex ] ; configIndex++ )
	    	{
	    	    if( (cp = bulkLoadConfig.titleTokenscp[ tokenIndex ][ configIndex ]) != NULLCP )
			(void)free( cp ) ;
		}
	    }
	    
	    bulkLoadConfig.lastUsedTitlesToken[ tokenIndex ] = -1 ;
	}
	
	if( firstInitialisation == FALSE )
	{
	    if( bulkLoadConfig.checkAttrTypeForDeleteEntry != NULLAttrT )
	    {
	    	AttrT_free( bulkLoadConfig.checkAttrTypeForDeleteEntry ) ;
		bulkLoadConfig.checkAttrTypeForDeleteEntry = NULLAttrT ;
	    }

	    for( tokenIndex = 0 ; tokenIndex < CONFIGNUMPERIODBEFOREDELTOKENS ; tokenIndex ++ )
	    {
		if( bulkLoadConfig.periodBeforeDeletionAttrV[ tokenIndex ] != NULLAttrV )
		{
		    AttrV_free( bulkLoadConfig.periodBeforeDeletionAttrV[ tokenIndex ] ) ;
		    bulkLoadConfig.periodBeforeDeletionAttrV[ tokenIndex ] = NULLAttrV ;
		}
	    }

	}

	for( tokenIndex = 0 ; tokenIndex < CONFIGNUMPERIODBEFOREDELTOKENS ; tokenIndex ++ )
	    bulkLoadConfig.periodBeforeDeletionForAttrV[ tokenIndex ] = CONFIGNOLIMITPERIODBEFOREDEL ;

	bulkLoadConfig.checkAttrTypeForDeleteEntry = NULLAttrT ;

	bulkLoadConfig.lastUsedPeriodBeforeDeleteToken = -1 ;

	bulkLoadConfig.commonNameSearchFormat = STARINITSTARSPACESURNAMESTAR ;
	    
	bulkLoadConfig.replaceFullStopCommonNameDelimsWithSpaces = TRUE ;

	if( firstInitialisation == TRUE )
	    bulkLoadConfig.dsaErrorLogFileNamecp = NULLCP ;

	else if( bulkLoadConfig.dsaErrorLogFileNamecp != NULLCP ) {
	    (void)free( bulkLoadConfig.dsaErrorLogFileNamecp ) ;
	    bulkLoadConfig.dsaErrorLogFileNamecp = NULLCP ;
	}

	bulkLoadConfig.dsaErrorLogTailNBytes = 0 ;

	return ;
}


int
convProcReqTokenToNum( rightToken )
char *	rightToken ;
{
int	processingReq = INVALIDPROCESSING ;

	if( strncasecmp( rightToken, "NOACTION", 8 ) == 0 )
	    processingReq = OUTPUTNOACTIONFILE ;

	else if( strncasecmp( rightToken, "PROBLEM", 7 ) == 0 )
	    processingReq = OUTPUTPROBLEMFILE ;

	else if( strncasecmp( rightToken, "PROCESS", 7 ) == 0 )
	    processingReq = PROCESSTHEUPDATE ;

	return( processingReq ) ;
}

void
checkYesNoToken( leftToken, rightToken, flagp, diagnosticcp )
char *	leftToken, * rightToken ;
int  *	flagp ;
char *	diagnosticcp ;
{
	if( strncasecmp( rightToken, "YES", 1 ) != 0 && strncasecmp( rightToken, "NO", 1 ) != 0 )
	{
	    if( diagnosticcp != NULLCP )
	    	sprintf( diagnosticcp, "%s \"%s : %s\"", "The right token should be YES or NO", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "The right token should be YES or NO", leftToken, rightToken ) ;
#endif		
	}
	else
	{
	    *flagp = ((strncasecmp( rightToken, "YES", 1 ) == 0) ? TRUE : FALSE) ;
	}

	return ; /* An error condition will be notified by the diagnostics string */
}

int
processSourceReportParamLine( leftToken, rightToken, diagnosticcp )
char *	leftToken, * rightToken, * diagnosticcp ;
{
char *	leftQuotecp, * rightQuotecp ;
int	tokenProcessed = FALSE, level ;

	if( diagnosticcp != NULLCP )
	    *diagnosticcp = '\0' ;

	if( managementConfig.returnToMenu == TRUE )
	    return( TRUE ) ;
	
	removeAllWhiteSpaces( leftToken ) ;

	if( strchr( rightToken, '"' ) == NULLCP )
	    removeAllWhiteSpaces( rightToken ) ;
	else if( *(rightToken + strlen( rightToken ) - 1 ) == '\n' )
	    *(rightToken + strlen( rightToken ) - 1 ) = '\0' ;
	    
	if( strcasecmp( leftToken, "Sub-treeparentDN" ) == 0 )
	{
	    if( (leftQuotecp  = strchr( rightToken, '"' ))  == NULLCP ||
	        (rightQuotecp = strrchr( rightToken, '"' )) == NULLCP ||
		leftQuotecp  == rightQuotecp )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "The distinguished name must be quoted", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "The distinguished name must be quoted", leftToken, rightToken ) ;
#endif
	    }
	    else 
	    {
	    	*rightQuotecp = '\0' ;

		if( (managementConfig.sourceReportSubTreeParentDN = str2dn( leftQuotecp+1 )) == NULLDN )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid Distinguished Name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid Distinguished Name", leftToken, rightToken ) ;
#endif
		}
		else {
	    	    managementConfig.sourceReportSubTreeParentDNcp = strdup( leftQuotecp+1 ) ;
		}
	    }

	    tokenProcessed = TRUE ;		
	}
	else {

	    if( strcasecmp( leftToken, "Numberoflevelstosearch" ) == 0 )
	    {
	    	if( (level = atoi( rightToken )) <= 0 || level > 9 )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Missing or out of range level", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Missing or out of range level", leftToken, rightToken ) ;
#endif
		}
		else managementConfig.sourceReportLevels = level ;
		
	    	tokenProcessed = TRUE ;	
	    }
	    else if( strcasecmp( leftToken, "Outputfilename" ) == 0 )
	    {
	    	if( strlen( rightToken ) == 0 )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid file name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid file name", leftToken, rightToken ) ;
#endif
		}
		else managementConfig.sourceReportFileNamecp = strdup( rightToken ) ;

	    	tokenProcessed = TRUE ;
	    }
	    else if( strcasecmp( leftToken, "RETURNTOMENU" ) == 0 )
	    {
	    	checkYesNoToken( leftToken, rightToken, &(managementConfig.returnToMenu), diagnosticcp ) ;
		
	    	tokenProcessed = TRUE ;
	    }
	}

	if( tokenProcessed == FALSE )
	{
	    if( diagnosticcp != NULLCP )
		sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid left token in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid left token in", leftToken, rightToken ) ;
#endif
	}	

	return( tokenProcessed ) ;
}

int
processExpiredEntriesParamLine( leftToken, rightToken, diagnosticcp )
char *	leftToken, * rightToken, * diagnosticcp ;
{
char *	leftQuotecp, * rightQuotecp ;
int	tokenProcessed = FALSE ;
AttributeValue delAv ;

	if( diagnosticcp != NULLCP )
	    *diagnosticcp = '\0' ;

	if( managementConfig.returnToMenu == TRUE )
	    return( TRUE ) ;

	removeAllWhiteSpaces( leftToken ) ;

	if( strchr( rightToken, '"' ) == NULLCP )	    
	    removeAllWhiteSpaces( rightToken ) ;
	else if( *(rightToken + strlen( rightToken ) - 1 ) == '\n' )
	    *(rightToken + strlen( rightToken ) - 1 ) = '\0' ;		
	    
	if( strcasecmp( leftToken, "Sub-treeparentDN" ) == 0 )
	{
	    if( (leftQuotecp  = strchr( rightToken, '"' ))  == NULLCP ||
	        (rightQuotecp = strrchr( rightToken, '"' )) == NULLCP ||
		leftQuotecp  == rightQuotecp )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "The distinguished name must be quoted", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "The distinguished name must be quoted", leftToken, rightToken ) ;
#endif
	    }
	    else 
	    {
	    	*rightQuotecp = '\0' ;

		if( (managementConfig.expiredEntriesSubTreeParentDN = str2dn( leftQuotecp+1 )) == NULLDN )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid Distinguished Name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid Distinguished Name", leftToken, rightToken ) ;
#endif
		}
		else {
	    	    managementConfig.expiredEntriesSubTreeParentDNcp = strdup( leftQuotecp+1 ) ;
		}
	    }

	    tokenProcessed = TRUE ;
	}
	else {

	    if( strcasecmp( leftToken, "Entryexpirydate" ) == 0 )
	    {
	    	if( (delAv = str2AttrV( rightToken, str2syntax( BL_UTC_TIME ))) == NULLAttrV )
	    	{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid UTC time", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid UTC time", leftToken, rightToken ) ;
#endif
	    	}
	    	else
	    	{
	    	    managementConfig.expiredEntriesUTCtimecp = strdup( rightToken ) ;
		    AttrV_free( delAv ) ;
	    	}

	    	tokenProcessed = TRUE ;
	    }
	    else if( strcasecmp( leftToken, "Outputfilename" ) == 0 )
	    {
	    	if( strlen( rightToken ) == 0 )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid file name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid file name", leftToken, rightToken ) ;
#endif
		}
		else managementConfig.expiredEntriesLogFileNamecp = strdup( rightToken ) ;

	    	tokenProcessed = TRUE ;
	    }
	    else if( strcasecmp( leftToken, "RETURNTOMENU" ) == 0 )
	    {
	    	checkYesNoToken( leftToken, rightToken, &(managementConfig.returnToMenu), diagnosticcp ) ;
		
	    	tokenProcessed = TRUE ;
	    }
	}

	if( tokenProcessed == FALSE )
	{
	    if( diagnosticcp != NULLCP )
		sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid left token in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid left token in", leftToken, rightToken ) ;
#endif
	}	
	return( tokenProcessed ) ;
}



int
processDumpSubtreeParamLine( leftToken, rightToken, diagnosticcp )
char *	leftToken, * rightToken, * diagnosticcp ;
{
char *	leftQuotecp, * rightQuotecp ;
int	tokenProcessed = FALSE ;

	if( diagnosticcp != NULLCP )
	    *diagnosticcp = '\0' ;

	if( managementConfig.returnToMenu == TRUE )
	    return( TRUE ) ;

	removeAllWhiteSpaces( leftToken ) ;

	if( strchr( rightToken, '"' ) == NULLCP )
	    removeAllWhiteSpaces( rightToken ) ;
	else if( *(rightToken + strlen( rightToken ) - 1 ) == '\n' )
	    *(rightToken + strlen( rightToken ) - 1 ) = '\0' ;
	    
	if( strcasecmp( leftToken, "Sub-treeparentDN" ) == 0 )
	{
	    if( (leftQuotecp  = strchr( rightToken, '"' ))  == NULLCP ||
	        (rightQuotecp = strrchr( rightToken, '"' )) == NULLCP ||
		leftQuotecp  == rightQuotecp )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "The distinguished name must be quoted", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "The distinguished name must be quoted", leftToken, rightToken ) ;
#endif
	    }
	    else 
	    {
	    	*rightQuotecp = '\0' ;

		if( (managementConfig.dumpSubtreeSubTreeParentDN = str2dn( leftQuotecp+1 )) == NULLDN )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid Distinguished Name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid Distinguished Name", leftToken, rightToken ) ;
#endif
		}
		else {
	    	    managementConfig.dumpSubtreeSubTreeParentDNcp = strdup( leftQuotecp+1 ) ;
		}
	    }

	    tokenProcessed = TRUE ;		
	}
	else {

	    if( strcasecmp( leftToken, "Outputfilename" ) == 0 )
	    {
	    	if( strlen( rightToken ) == 0 )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid file name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid file name", leftToken, rightToken ) ;
#endif
		}
		else managementConfig.dumpSubtreeFileNamecp = strdup( rightToken ) ;

	    	tokenProcessed = TRUE ;
	    }
	    else if( strcasecmp( leftToken, "RETURNTOMENU" ) == 0 )
	    {
	    	checkYesNoToken( leftToken, rightToken, &(managementConfig.returnToMenu), diagnosticcp ) ;
		
	    	tokenProcessed = TRUE ;
	    }
	}

	if( tokenProcessed == FALSE )
	{
	    if( diagnosticcp != NULLCP )
		sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid left token in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid left token in", leftToken, rightToken ) ;
#endif
	}	

	return( tokenProcessed ) ;
}

int
processAddValueToSubtreeParamLine( leftToken, rightToken, diagnosticcp )
char *	leftToken, * rightToken, * diagnosticcp ;
{
char *	leftQuotecp, * rightQuotecp ;
int	tokenProcessed = FALSE ;

	if( diagnosticcp != NULLCP )
	    *diagnosticcp = '\0' ;

	if( managementConfig.returnToMenu == TRUE )
	    return( TRUE ) ;

	removeAllWhiteSpaces( leftToken ) ;

	if( strchr( rightToken, '"' ) == NULLCP )
	    removeAllWhiteSpaces( rightToken ) ;
	else if( *(rightToken + strlen( rightToken ) - 1 ) == '\n' )
	    *(rightToken + strlen( rightToken ) - 1 ) = '\0' ;

	if( strcasecmp( leftToken, "Sub-treeparentDN" ) == 0 )
	{
	    if( (leftQuotecp  = strchr( rightToken, '"' ))  == NULLCP ||
	        (rightQuotecp = strrchr( rightToken, '"' )) == NULLCP ||
		leftQuotecp  == rightQuotecp )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "The distinguished name must be quoted", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "The distinguished name must be quoted", leftToken, rightToken ) ;
#endif
	    }
	    else 
	    {
	    	*rightQuotecp = '\0' ;

		if( (managementConfig.addValueToSubTreeParentDN = str2dn( leftQuotecp+1 )) == NULLDN )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid Distinguished Name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid Distinguished Name", leftToken, rightToken ) ;
#endif
		}
		else {
	    	    managementConfig.addValueToSubTreeParentDNcp = strdup( leftQuotecp+1 ) ;
		}
	    }

	    tokenProcessed = TRUE ;		
	}
	else {
	    
	    if( strcasecmp( leftToken, "Addvaluetojusttheleafnodes" ) == 0 )
	    {
	    	checkYesNoToken( leftToken, rightToken, &(managementConfig.addValueToJustLeafNodes), diagnosticcp ) ;

	    	tokenProcessed = TRUE ;
	    } 
	    else if( strcasecmp( leftToken, "AttributeType" ) == 0 )
	    {
		if( (managementConfig.addValueToSubTreeAt = str2AttrT( rightToken )) == NULLAttrT )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid Attribute Type", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid Attribute Type", leftToken, rightToken ) ;
#endif
		}
		
		tokenProcessed = TRUE ;
	    } 
	    else if( strcasecmp( leftToken, "AttributeValue" ) == 0 )
	    {
	    	if( managementConfig.addValueToSubTreeAt == NULLAttrT )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Missing Attribute Type before", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Missing Attribute Type before", leftToken, rightToken ) ;
#endif
		
		}
		else if( (managementConfig.addValueToSubTreeAv = 
			  str_at2AttrV( rightToken, managementConfig.addValueToSubTreeAt )) == NULLAttrV )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid Attribute Value", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid Attribute Value", leftToken, rightToken ) ;
#endif
		}
		
	    	tokenProcessed = TRUE ;
	    }
	    else if( strcasecmp( leftToken, "RETURNTOMENU" ) == 0 )
	    {
	    	checkYesNoToken( leftToken, rightToken, &(managementConfig.returnToMenu), diagnosticcp ) ;
		
	    	tokenProcessed = TRUE ;
	    }
	}

	if( tokenProcessed == FALSE )
	{
	    if( diagnosticcp != NULLCP )
		sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid left token in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid left token in", leftToken, rightToken ) ;
#endif
	}	

	return( tokenProcessed ) ;
}

int
processResetValidCheckAtParamLine( leftToken, rightToken, diagnosticcp )
char *	leftToken, * rightToken, * diagnosticcp ;
{
char *	leftQuotecp, * rightQuotecp ;
int	tokenProcessed = FALSE ;
AttributeValue validChkAtAv ;

	if( diagnosticcp != NULLCP )
	    *diagnosticcp = '\0' ;

	if( managementConfig.returnToMenu == TRUE )
	    return( TRUE ) ;

	removeAllWhiteSpaces( leftToken ) ;

	if( strchr( rightToken, '"' ) == NULLCP )	    
	    removeAllWhiteSpaces( rightToken ) ;
	else if( *(rightToken + strlen( rightToken ) - 1 ) == '\n' )
	    *(rightToken + strlen( rightToken ) - 1 ) = '\0' ;		

	if( strcasecmp( leftToken, "Sub-treeparentDN" ) == 0 )
	{
	    if( (leftQuotecp  = strchr( rightToken, '"' ))  == NULLCP ||
	        (rightQuotecp = strrchr( rightToken, '"' )) == NULLCP ||
		leftQuotecp  == rightQuotecp )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "The distinguished name must be quoted", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "The distinguished name must be quoted", leftToken, rightToken ) ;
#endif
	    }
	    else 
	    {
	    	*rightQuotecp = '\0' ;

		if( (managementConfig.resetValidChkAtSubTreeParentDN = str2dn( leftQuotecp+1 )) == NULLDN )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid Distinguished Name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid Distinguished Name", leftToken, rightToken ) ;
#endif
		}
		else {
	    	    managementConfig.resetValidChkAtSubTreeParentDNcp = strdup( leftQuotecp+1 ) ;
		}
	    }

	    tokenProcessed = TRUE ;
	}
	else {
	    
	    if( strcasecmp( leftToken, "ResetvalidationCheckAttime" ) == 0 )
	    {
	    	if( (validChkAtAv = str2AttrV( rightToken, str2syntax( BL_UTC_TIME ))) == NULLAttrV )
	    	{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid UTC time", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid UTC time", leftToken, rightToken ) ;
#endif
	    	}
	    	else
	    	{
	    	    managementConfig.resetValidChkAtUTCtimecp = strdup( rightToken ) ;
		    AttrV_free( validChkAtAv ) ;
	    	}

	    	tokenProcessed = TRUE ;
	    }
	    else if( strcasecmp( leftToken, "Outputfilename" ) == 0 )
	    {
	    	if( strlen( rightToken ) == 0 )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid file name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid file name", leftToken, rightToken ) ;
#endif
		}
		else managementConfig.resetValidChkAtLogFileNamecp = strdup( rightToken ) ;

	    	tokenProcessed = TRUE ;
	    }
	    else if( strcasecmp( leftToken, "RETURNTOMENU" ) == 0 )
	    {
	    	checkYesNoToken( leftToken, rightToken, &(managementConfig.returnToMenu), diagnosticcp ) ;
		
	    	tokenProcessed = TRUE ;
	    }
	}

	if( tokenProcessed == FALSE )
	{
	    if( diagnosticcp != NULLCP )
		sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid left token in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid left token in", leftToken, rightToken ) ;
#endif
	}	

	return( tokenProcessed ) ;
}


int
processSourceValidationParamLine( leftToken, rightToken, diagnosticcp )
char *	leftToken, * rightToken, * diagnosticcp ;
{
int	tokenProcessed = FALSE ;

	if( diagnosticcp != NULLCP )
	    *diagnosticcp = '\0' ;

	if( managementConfig.returnToMenu == TRUE )
	    return( TRUE ) ;

	removeAllWhiteSpaces( leftToken ) ;

	if( strchr( rightToken, '"' ) == NULLCP )
	    removeAllWhiteSpaces( rightToken ) ;
	else if( *(rightToken + strlen( rightToken ) - 1 ) == '\n' )
	    *(rightToken + strlen( rightToken ) - 1 ) = '\0' ;		
	    
	if( strcasecmp( leftToken, "Inputfilename" ) == 0 )
	{
	    if( strlen( rightToken ) == 0 )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid file name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid file name", leftToken, rightToken ) ;
#endif
	    }
	    else managementConfig.sourceValidationInputFileNamecp = strdup( rightToken ) ;

	    tokenProcessed = TRUE ;
	}
	else if( strcasecmp( leftToken, "RETURNTOMENU" ) == 0 )
	{
	    checkYesNoToken( leftToken, rightToken, &(managementConfig.returnToMenu), diagnosticcp ) ;
		
	    tokenProcessed = TRUE ;
	}

	if( tokenProcessed == FALSE )
	{
	    if( diagnosticcp != NULLCP )
		sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid left token in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid left token in", leftToken, rightToken ) ;
#endif
	}	

	return( tokenProcessed ) ;
}


int
processCheckValidCheckAtParamLine( leftToken, rightToken, diagnosticcp )
char *	leftToken, * rightToken, * diagnosticcp ;
{
int	tokenProcessed = FALSE ;
char *	leftQuotecp, * rightQuotecp ;
AttributeValue	validChkAtAv ;

	if( diagnosticcp != NULLCP )
	    *diagnosticcp = '\0' ;

	if( managementConfig.returnToMenu == TRUE )
	    return( TRUE ) ;

	removeAllWhiteSpaces( leftToken ) ;

	if( strchr( rightToken, '"' ) == NULLCP )
	    removeAllWhiteSpaces( rightToken ) ;
	else if( *(rightToken + strlen( rightToken ) - 1 ) == '\n' )
	    *(rightToken + strlen( rightToken ) - 1 ) = '\0' ;

	if( strcasecmp( leftToken, "Sub-treeparentDN" ) == 0 )
	{
	    if( (leftQuotecp  = strchr( rightToken, '"' ))  == NULLCP ||
	        (rightQuotecp = strrchr( rightToken, '"' )) == NULLCP ||
		leftQuotecp  == rightQuotecp )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "The distinguished name must be quoted", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "The distinguished name must be quoted", leftToken, rightToken ) ;
#endif
	    }
	    else 
	    {
	    	*rightQuotecp = '\0' ;

		if( (managementConfig.checkValidChkAtSubTreeParentDN = str2dn( leftQuotecp+1 )) == NULLDN )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid Distinguished Name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid Distinguished Name", leftToken, rightToken ) ;
#endif
		}
		else {
	    	    managementConfig.checkValidChkAtSubTreeParentDNcp = strdup( leftQuotecp+1 ) ;
		}
	    }

	    tokenProcessed = TRUE ;
	}
	else {
	    
	    if( strcasecmp( leftToken, "CheckvalidationCheckAttime" ) == 0 )
	    {
	    	if( (validChkAtAv = str2AttrV( rightToken, str2syntax( BL_UTC_TIME ))) == NULLAttrV )
	    	{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid UTC time", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid UTC time", leftToken, rightToken ) ;
#endif
	    	}
	    	else
	    	{
	    	    managementConfig.checkValidChkAtUTCtimecp = strdup( rightToken ) ;
		    AttrV_free( validChkAtAv ) ;
	    	}

	    	tokenProcessed = TRUE ;
	    }
	    else if( strcasecmp( leftToken, "Outputfilename" ) == 0 )
	    {
	    	if( strlen( rightToken ) == 0 )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid file name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid file name", leftToken, rightToken ) ;
#endif
		}
		else managementConfig.checkValidChkAtLogFileNamecp = strdup( rightToken ) ;

	    	tokenProcessed = TRUE ;
	    }
	    else if( strcasecmp( leftToken, "RETURNTOMENU" ) == 0 )
	    {
	    	checkYesNoToken( leftToken, rightToken, &(managementConfig.returnToMenu), diagnosticcp ) ;
		
	    	tokenProcessed = TRUE ;
	    }
	}

	if( tokenProcessed == FALSE )
	{
	    if( diagnosticcp != NULLCP )
		sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid left token in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid left token in", leftToken, rightToken ) ;
#endif
	}	

	return( tokenProcessed ) ;
}

int
processMasterUpAtforNonMasterUpAtParamLine( leftToken, rightToken, diagnosticcp )
char *	leftToken, * rightToken, * diagnosticcp ;
{
int	tokenProcessed = FALSE ;
char *	leftQuotecp, * rightQuotecp, modecp ;

	if( diagnosticcp != NULLCP )
	    *diagnosticcp = '\0' ;

	if( managementConfig.returnToMenu == TRUE )
	    return( TRUE ) ;

	removeAllWhiteSpaces( leftToken ) ;

	if( strchr( rightToken, '"' ) == NULLCP )
	    removeAllWhiteSpaces( rightToken ) ;
	else if( *(rightToken + strlen( rightToken ) - 1 ) == '\n' )
	    *(rightToken + strlen( rightToken ) - 1 ) = '\0' ;

	if( strcasecmp( leftToken, "Sub-treeparentDN" ) == 0 )
	{
	    if( (leftQuotecp  = strchr( rightToken, '"' ))  == NULLCP ||
	        (rightQuotecp = strrchr( rightToken, '"' )) == NULLCP ||
		leftQuotecp  == rightQuotecp )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "The distinguished name must be quoted", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "The distinguished name must be quoted", leftToken, rightToken ) ;
#endif
	    }
	    else 
	    {
	    	*rightQuotecp = '\0' ;

		if( (managementConfig.masterUpAtToNonMasterSubTreeParentDN = str2dn( leftQuotecp+1 )) == NULLDN )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid Distinguished Name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid Distinguished Name", leftToken, rightToken ) ;
#endif
		}
		else {
	    	    managementConfig.masterUpAtToNonMasterSubTreeParentDNcp = strdup( leftQuotecp+1 ) ;
		}
	    }

	    tokenProcessed = TRUE ;
	}
	else {

	    if( strcasecmp( leftToken, "ExchangeorRemove" ) == 0 )
	    {
	    	if( (modecp = tolower( *rightToken )) != 'e' && modecp != 'r' )
	    	{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid mode", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid mode", leftToken, rightToken ) ;
#endif
	    	}
	    	else
	    	{
	    	    managementConfig.masterUpAtToNonMasterMode = modecp ;
	    	}

	    	tokenProcessed = TRUE ;
	    }
	    else if( strcasecmp( leftToken, "Outputfilename" ) == 0 )
	    {
	    	if( strlen( rightToken ) == 0 )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid file name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid file name", leftToken, rightToken ) ;
#endif
		}
		else managementConfig.masterUpAtToNonMasterLogFileNamecp = strdup( rightToken ) ;

	    	tokenProcessed = TRUE ;
	    }
	    else if( strcasecmp( leftToken, "RETURNTOMENU" ) == 0 )
	    {
	    	checkYesNoToken( leftToken, rightToken, &(managementConfig.returnToMenu), diagnosticcp ) ;
		
	    	tokenProcessed = TRUE ;
	    }
	}

	if( tokenProcessed == FALSE )
	{
	    if( diagnosticcp != NULLCP )
		sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid left token in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid left token in", leftToken, rightToken ) ;
#endif
	}	

	return( tokenProcessed ) ;
}


int
processCheckDNParamLine( leftToken, rightToken, diagnosticcp )
char *	leftToken, * rightToken, * diagnosticcp ;
{
int	tokenProcessed = FALSE ;
char *	leftQuotecp, * rightQuotecp ;
struct  checkDNAttrTNode * nextCheckDNAttrTNodep ;
AttributeType at ;
static	int dnsyntax = -1 ;

	if( dnsyntax == -1 )
	    dnsyntax = str2syntax( "DN" ) ;

	if( diagnosticcp != NULLCP )
	    *diagnosticcp = '\0' ;

/*	if( managementConfig.returnToMenu == TRUE )
	    return( TRUE ) ;
 ,,,We need to buffer the "CheckDNAttrT"s */

	removeAllWhiteSpaces( leftToken ) ;

	if( strchr( rightToken, '"' ) == NULLCP )
	    removeAllWhiteSpaces( rightToken ) ;
	else if( *(rightToken + strlen( rightToken ) - 1 ) == '\n' )
	    *(rightToken + strlen( rightToken ) - 1 ) = '\0' ;

	if( strcasecmp( leftToken, "Sub-treeparentDN" ) == 0 )
	{
	    if( (leftQuotecp  = strchr( rightToken, '"' ))  == NULLCP ||
	        (rightQuotecp = strrchr( rightToken, '"' )) == NULLCP ||
		leftQuotecp  == rightQuotecp )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "The distinguished name must be quoted", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "The distinguished name must be quoted", leftToken, rightToken ) ;
#endif
	    }
	    else 
	    {
	    	*rightQuotecp = '\0' ;

		if( (managementConfig.checkDNSubTreeParentDN = str2dn( leftQuotecp+1 )) == NULLDN )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid Distinguished Name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid Distinguished Name", leftToken, rightToken ) ;
#endif
		}
		else {
	    	    managementConfig.checkDNSubTreeParentDNcp = strdup( leftQuotecp+1 ) ;
		}
	    }

	    tokenProcessed = TRUE ;
	}
	else {

	    if( strcasecmp( leftToken, "CheckDNAttrT" ) == 0 )
	    {
	    	if( (at = str2AttrT( rightToken )) == NULLAttrT )
	    	{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid Attribute Type", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid Attribute Type", leftToken, rightToken ) ;
#endif
		} else if( at->oa_syntax != dnsyntax ) {

		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Attribute type does not have DN syntax", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Attribute type does not have DN syntax", leftToken, rightToken ) ;
#endif
		} else {

		    /* Add this attribute type to the current list... */
		    nextCheckDNAttrTNodep = managementConfig.checkDNAttrTs ;

		    if((managementConfig.checkDNAttrTs =
				(struct checkDNAttrTNode*)malloc( sizeof( struct checkDNAttrTNode ) )) != NULL ) {

			managementConfig.checkDNAttrTs->checkDNAttrT = at ;
			managementConfig.checkDNAttrTs->nextCheckDNAttrTNode = nextCheckDNAttrTNodep ;
			
		    } else {
			 AttrT_free( at ) ;
#ifdef BLT_DEBUG
fprintf( stderr, "Malloc failure in processCheckDNParamLine()" ) ;
#endif
		    }
		}

	    	tokenProcessed = TRUE ;
	    }
	    else if( strcasecmp( leftToken, "Outputfilename" ) == 0 )
	    {
	    	if( strlen( rightToken ) == 0 )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid file name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid file name", leftToken, rightToken ) ;
#endif
		}
		else managementConfig.checkDNLogFileNamecp = strdup( rightToken ) ;

	    	tokenProcessed = TRUE ;
	    }
	    else if( strcasecmp( leftToken, "RETURNTOMENU" ) == 0 )
	    {
	    	checkYesNoToken( leftToken, rightToken, &(managementConfig.returnToMenu), diagnosticcp ) ;
		
	    	tokenProcessed = TRUE ;
	    }
	}

	if( tokenProcessed == FALSE )
	{
	    if( diagnosticcp != NULLCP )
		sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid left token in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid left token in", leftToken, rightToken ) ;
#endif
	}	

	return( tokenProcessed ) ;
}


int
processRoleOccXrefParamLine( leftToken, rightToken, diagnosticcp )
char *	leftToken, * rightToken, * diagnosticcp ;
{
int	tokenProcessed = FALSE ;
char *	leftQuotecp, * rightQuotecp ;

	if( diagnosticcp != NULLCP )
	    *diagnosticcp = '\0' ;

	if( managementConfig.returnToMenu == TRUE )
	    return( TRUE ) ;

	removeAllWhiteSpaces( leftToken ) ;

	if( strchr( rightToken, '"' ) == NULLCP )
	    removeAllWhiteSpaces( rightToken ) ;
	else if( *(rightToken + strlen( rightToken ) - 1 ) == '\n' )
	    *(rightToken + strlen( rightToken ) - 1 ) = '\0' ;

	if( strcasecmp( leftToken, "Sub-treeparentDN" ) == 0 )
	{
	    if( (leftQuotecp  = strchr( rightToken, '"' ))  == NULLCP ||
	        (rightQuotecp = strrchr( rightToken, '"' )) == NULLCP ||
		leftQuotecp  == rightQuotecp )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "The distinguished name must be quoted", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "The distinguished name must be quoted", leftToken, rightToken ) ;
#endif
	    }
	    else 
	    {
	    	*rightQuotecp = '\0' ;

		if( (managementConfig.roleOccXrefSubTreeParentDN = str2dn( leftQuotecp+1 )) == NULLDN )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid Distinguished Name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid Distinguished Name", leftToken, rightToken ) ;
#endif
		}
		else {
	    	    managementConfig.roleOccXrefSubTreeParentDNcp = strdup( leftQuotecp+1 ) ;
		}
	    }

	    tokenProcessed = TRUE ;
	}
	else {

	    if( strcasecmp( leftToken, "Outputfilename" ) == 0 )
	    {
	    	if( strlen( rightToken ) == 0 )
		{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid file name", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid file name", leftToken, rightToken ) ;
#endif
		}
		else managementConfig.roleOccXrefLogFileNamecp = strdup( rightToken ) ;

	    	tokenProcessed = TRUE ;
	    }
	    else if( strcasecmp( leftToken, "RETURNTOMENU" ) == 0 )
	    {
	    	checkYesNoToken( leftToken, rightToken, &(managementConfig.returnToMenu), diagnosticcp ) ;
		
	    	tokenProcessed = TRUE ;
	    }
	}

	if( tokenProcessed == FALSE )
	{
	    if( diagnosticcp != NULLCP )
		sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid left token in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid left token in", leftToken, rightToken ) ;
#endif
	}	

	return( tokenProcessed ) ;
}


int
processManagementConfigLine( leftToken, rightToken, diagnosticcp )
char *	leftToken, * rightToken, * diagnosticcp ;
{	
char *	leftQuotecp, * rightQuotecp ;
int	tokenProcessed = FALSE ;
struct  checkDNAttrTNode * nextCheckDNAttrTNodep ;
AttributeType at ;
static	int dnsyntax = -1 ;

	if( dnsyntax == -1 )
	    dnsyntax = str2syntax( "DN" ) ;

	if( diagnosticcp != NULLCP )
	    *diagnosticcp = '\0' ;

	removeAllWhiteSpaces( leftToken ) ;

	if( strchr( rightToken, '"' ) == NULLCP )
	    removeAllWhiteSpaces( rightToken ) ;
	else if( *(rightToken + strlen( rightToken ) - 1 ) == '\n' )
	    *(rightToken + strlen( rightToken ) - 1 ) = '\0' ;	    

	if( strcasecmp( leftToken, "defaultDN" ) == 0 )
	{
	    if( (leftQuotecp  = strchr( rightToken, '"' ))  == NULLCP ||
	        (rightQuotecp = strrchr( rightToken, '"' )) == NULLCP ||
		leftQuotecp  == rightQuotecp )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "The distinguished name must be quoted", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "The distinguished name must be quoted", leftToken, rightToken ) ;
#endif
	    }
	    else
	    {
	    	*rightQuotecp = '\0' ;
	    	managementConfig.defaultDNcp = strdup( leftQuotecp+1 ) ;
	    }

	    tokenProcessed = TRUE ;		

	} else {

	    if( strcasecmp( leftToken, "CheckDNAttrT" ) == 0 )
	    {
	    	if( (at = str2AttrT( rightToken )) == NULLAttrT )
	    	{
		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid Attribute Type", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid Attribute Type", leftToken, rightToken ) ;
#endif
		} else if( at->oa_syntax != dnsyntax ) {

		    if( diagnosticcp != NULLCP )
		    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Attribute type does not have DN syntax", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Attribute type does not have DN syntax", leftToken, rightToken ) ;
#endif
		} else {

		    /* Add this attribute type to the current list... */
		    nextCheckDNAttrTNodep = managementConfig.checkDNAttrTs ;

		    if((managementConfig.checkDNAttrTs =
				(struct checkDNAttrTNode*)malloc( sizeof( struct checkDNAttrTNode ) )) != NULL ) {

			managementConfig.checkDNAttrTs->checkDNAttrT = at ;
			managementConfig.checkDNAttrTs->nextCheckDNAttrTNode = nextCheckDNAttrTNodep ;
			
		    } else {
			 AttrT_free( at ) ;
#ifdef BLT_DEBUG
fprintf( stderr, "Malloc failure in processManagementConfigLine()" ) ;
#endif
		    }
		}

	    	tokenProcessed = TRUE ;
	    }
	}

	if( tokenProcessed == FALSE )
	{
	    if( diagnosticcp != NULLCP )
		sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid left token in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid bulkmanagment (may be bulkload) left token in", leftToken, rightToken ) ;
#endif
	}	
	
	return( tokenProcessed ) ;
}


/*
 * If the tokens correspond to an error or title configuration token
 * then the configuration table is updated. On error the diagnostic
 * parameter will be loaded with an error message.
 */

int
processBulkLoadConfigLine( leftToken, rightToken, diagnosticcp )
char *	leftToken, * rightToken, * diagnosticcp ;
{
int	tokenIndex, rightValue, tokenProcessed = FALSE, searchLevel ;
struct	autoInsertNode * lastAutoInsertNodep ;
AttributeType	at = NULLAttrT ;
AttributeValue	av = NULLAttrV ;
char *	coloncp ;
int	tailNbytes ;

	if( diagnosticcp != NULLCP )
	    *diagnosticcp = '\0' ;

	removeAllWhiteSpaces( leftToken ) ;

	if( strchr( rightToken, '"' ) == NULLCP )
	    removeAllWhiteSpaces( rightToken ) ;
	else if( *(rightToken + strlen( rightToken ) - 1 ) == '\n' )
	    *(rightToken + strlen( rightToken ) - 1 ) = '\0' ;
	
	if( strcasecmp( leftToken, "autoInsertOnAttrT" ) == 0 )
	{
	    if( (at = str2AttrT( rightToken )) == NULLAttrT )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "Unknown attribute type in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Unknown attribute type in", leftToken, rightToken ) ;
#endif
	    }	    
	    else {
	    	(void)appendNewAutoInsertNode( &(bulkLoadConfig.autoInsertNodep), at ) ;
	    }
	    
	    tokenProcessed = TRUE ;	
	}
	else if( strcasecmp( leftToken, "autoInsertOnAttrV" ) == 0 )
	{
	    lastAutoInsertNodep = findLastAutoInsertNode( bulkLoadConfig.autoInsertNodep ) ;

	    if( lastAutoInsertNodep == NULLAUTOINSERTNODE ||
	        lastAutoInsertNodep -> autoInsertOnAttrT == NULLAttrT )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "Preceding \"autoInsertOnAttrT\" statement missing for", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "No preceding \"autoInsertOnAttrT\" statement for", leftToken, rightToken ) ;
#endif
	    } 
	    else if( lastAutoInsertNodep -> autoInsertOnAttrV != NULLAttrV )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "Only one \"autoInsertOnAttrV\" per \"autoInsertOnAttrT\"", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Only one \"autoInsertOnAttrV\" per \"autoInsertOnAttrT\"", leftToken, rightToken ) ;
#endif
	    }
	    else if( (av = str_at2AttrV( rightToken, lastAutoInsertNodep->autoInsertOnAttrT )) == NULLAttrV )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "Could not encode attribute value in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Could not encode attribute value in", leftToken, rightToken ) ;
#endif
	    }
	    else {
		lastAutoInsertNodep -> autoInsertOnAttrV = av ;
	    }
	    
	    tokenProcessed = TRUE ;	
	}
	else if( strcasecmp( leftToken, "autoInsertObjCls" ) == 0 )
	{
	    lastAutoInsertNodep = findLastAutoInsertNode( bulkLoadConfig.autoInsertNodep ) ;

	    if( lastAutoInsertNodep == NULLAUTOINSERTNODE ||
	        lastAutoInsertNodep -> autoInsertOnAttrT == NULLAttrT )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "Preceding \"autoInsertOnAttrT\" statement missing for", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "No preceding \"autoInsertOnAttrT\" statement for", leftToken, rightToken ) ;
#endif
	    }
	    else if( lastAutoInsertNodep -> autoInsertOnAttrV == NULLAttrV )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "Preceding \"autoInsertOnAttrV\" statement missing for", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Preceding \"autoInsertOnAttrV\" statement missing for", leftToken, rightToken ) ;
#endif
	    }
	    else if( (av = str2AttrV( rightToken, str2syntax( "ObjectClass" ) )) == NULLAttrV )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "Could not encode attribute value in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Could not encode attribute value in", leftToken, rightToken ) ;
#endif
	    }
	    else {
	    	(void)appendNewAutoInsertObjClsListNode( &(lastAutoInsertNodep->autoInsertObjClsListp), av ) ;
	    }
	    
	    tokenProcessed = TRUE ;	
	}
	else if( strcasecmp( leftToken, "UniquekeyattrT" ) == 0 )
	{
	    if( (at = str2AttrT( rightToken )) == NULLAttrT )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "Unknown attribute type in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Unknown attribute type in", leftToken, rightToken ) ;
#endif
	    }	    
	    else {
	    	(void)appendNewUniqueKeyNode( &(bulkLoadConfig.uniqueKeyNodep), at ) ;
	    }
	    
	    tokenProcessed = TRUE ;
	}
	else if( strcasecmp( leftToken, "HighestdirectoryleveltosearchfordataSourceentries" ) == 0 )
	{
	    searchLevel = atoi( rightToken ) ;

	    if( searchLevel >= CONFIGHIGHESTDATASRCLEVEL && searchLevel<= CONFIGLOWESTDATASRCLEVEL )
	    {
		bulkLoadConfig.highestDataSourceSearchLevel = searchLevel ;
	    }
	    else
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid highest search level in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid highest search level in", leftToken, rightToken ) ;
#endif
	    }
	    
	    tokenProcessed = TRUE ;
	}
	else if( strcasecmp( leftToken, "Whennomasterspecifiedforatypeallsourcesaremasters" ) == 0 )
	{
	    checkYesNoToken( leftToken, rightToken, &(bulkLoadConfig.noMasterSpecifiedSoAllSourcesAreMasters), diagnosticcp ) ;
		
	    tokenProcessed = TRUE ;
	}
	else if( strcasecmp( leftToken, "Allsourcesaremastersfor" ) == 0 )
	{
	    at = NULLAttrT ;

	    if( bulkLoadConfig.lastUsedAttrTIndex >= (CONFIGNUMALLSRCMASTERS-1) )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s %d %s \"%s : %s\"", "Maximum attribute type count of", 
				CONFIGNUMALLSRCMASTERS, "exceeded for", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"", "Maximum attribute type count exceeded for", leftToken, rightToken ) ;
#endif
	    }
	    else if( (at = str2AttrT( rightToken )) == NULLAttrT )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "Unknown attribute type", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Unknown attribute type", leftToken, rightToken ) ;
#endif		
	    }
	    else if( at -> oa_syntax == 0 )
	    {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "%s \"%s : %s\"", "Unknown attribute syntax", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Unknown attribute syntax", leftToken, rightToken ) ;
#endif		
	    	AttrT_free( at ) ;
	    }
	    else
	    {
	    	bulkLoadConfig.allSourcesAreMastersForAttrT[ ++(bulkLoadConfig.lastUsedAttrTIndex) ] = at ;
#ifdef BLT_DEBUG
fprintf( stderr, "all source masters set up %d\n", bulkLoadConfig.lastUsedAttrTIndex ) ;
#endif
	    }

	    tokenProcessed = TRUE ;
	}
	else if( strcasecmp( leftToken, "Existingattrvaluemaybeclearedifmastersourceapplies1stvalue" ) == 0 )
	{
	    checkYesNoToken( leftToken, rightToken, &(bulkLoadConfig.valueClearDownPermittedOnFirstMasterUpdate), diagnosticcp ) ;
	
	    tokenProcessed = TRUE ;
	}
	else if( strcasecmp( leftToken, "Allsourcesarecreatesources" ) == 0 )
	{
	    checkYesNoToken( leftToken, rightToken, &(bulkLoadConfig.allSourcesAreCreateSources), diagnosticcp ) ;
		
	    tokenProcessed = TRUE ;
	}
	else if( strcasecmp( leftToken, "Autoconvertaddentrytoaddattributesifentryalreadyexists" ) == 0 )
	{
	    checkYesNoToken( leftToken, rightToken, &(bulkLoadConfig.autoAddEntryToAddAttrIfExists), diagnosticcp ) ;
		
	    tokenProcessed = TRUE ;
	}
	else if( strcasecmp( leftToken, "Displayconfigatstart" ) == 0 )
	{
	    checkYesNoToken( leftToken, rightToken, &(bulkLoadConfig.displayConfigAtStart), diagnosticcp ) ;
		
	    tokenProcessed = TRUE ;
	}
	else if( strcasecmp( leftToken, "CommonNameSearchFormat" ) == 0 )
	{
	    if( strcasecmp( rightToken, "STARINITSTARSPACESURNAMESTAR" ) == 0 )
	    	bulkLoadConfig.commonNameSearchFormat = STARINITSTARSPACESURNAMESTAR ;

	    else if( strcasecmp( rightToken, "STARINITSTARSURNAMESTAR" ) == 0 )
	    	bulkLoadConfig.commonNameSearchFormat = STARINITSTARSURNAMESTAR ;

	    else if( strcasecmp( rightToken, "STARSURNAMESPACEINITSTAR" ) == 0 )
	    	bulkLoadConfig.commonNameSearchFormat = STARSURNAMESPACEINITSTAR ;

	    else {

		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "Invalid search format for \"%s : %s\"", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "Invalid search format for \"%s : %s\"", leftToken, rightToken ) ;
#endif
	    }
	    
	    tokenProcessed = TRUE ;
	}
	else if( strcasecmp( leftToken, "Replacefullstopcommonnamedelimiterswithspaces" ) == 0 )
	{
	    checkYesNoToken( leftToken, rightToken, &(bulkLoadConfig.replaceFullStopCommonNameDelimsWithSpaces), diagnosticcp ) ;

	    tokenProcessed = TRUE ;
	}
	else if( strcasecmp( leftToken, "DSAerrorlogfilename" ) == 0 )
	{
	    bulkLoadConfig.dsaErrorLogFileNamecp = strdup( rightToken ) ;
	    tokenProcessed = TRUE ;
	}
	else if( strcasecmp( leftToken, "DSAerrorlogtailNBytes" ) == 0 )
	{
	    if((tailNbytes = atoi( rightToken )) <= MAXDSAERRLOGTAILNBYTES && tailNbytes >= 0 ) {

		bulkLoadConfig.dsaErrorLogTailNBytes = tailNbytes ;

	    } else {
		if( diagnosticcp != NULLCP )
		    sprintf( diagnosticcp, "Invalid number of bytes (0-%d) \"%s : %s\"", MAXDSAERRLOGTAILNBYTES, leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "Invalid number of bytes (0-%d) \"%s : %s\"", MAXDSAERRLOGTAILNBYTES, leftToken, rightToken ) ;
#endif
	    }

	    tokenProcessed = TRUE ;
	}
	else if( tokenProcessed == FALSE )
	{	
	    /* Try for a match against a titles token */
	    for( tokenIndex = 0 ; tokenProcessed == FALSE && tokenIndex < NUMCONFIGTITLETYPES ; tokenIndex++ )
	    {
	    	if( strcasecmp( leftToken, configTitleTokens[ tokenIndex ] ) == 0 )
	    	{
		    /* Check the number of tokens added so far.. */
		    if( bulkLoadConfig.lastUsedTitlesToken[ tokenIndex ] >= (CONFIGMAXNUMTITLETOKENS - 1))
		    {
		    	if( diagnosticcp != NULLCP )
			    sprintf( diagnosticcp, "%s %d %s \"%s : %s\"", "Maximum token count of", 
				    CONFIGMAXNUMTITLETOKENS, "exceeded for", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"", "Maximum token count exceeded for", leftToken, rightToken ) ;
#endif
		    }
		    else 
		    {
		    	bulkLoadConfig.titleTokenscp[ tokenIndex ][ ++(bulkLoadConfig.lastUsedTitlesToken[ tokenIndex ]) ] = strdup( rightToken ) ;
#ifdef BLT_DEBUG
fprintf( stderr, "config titles set up %d\n", bulkLoadConfig.lastUsedTitlesToken[ tokenIndex ] ) ;
#endif
		    }

	    	    tokenProcessed = TRUE ;
		}
	    }
	}

	if( tokenProcessed == FALSE )
	{
	    /* Try for a match against an errors token.. */
	    for( tokenIndex = 0 ; tokenProcessed == FALSE && tokenIndex < NUMCONFIGERRORTYPES ; tokenIndex++ )
	    {
	    	if( strcasecmp( leftToken, configErrorTokens[ tokenIndex ] ) == 0 )
	    	{
		    /* Check that the right token is valid.. */
		    if( (rightValue = convProcReqTokenToNum( rightToken )) == INVALIDPROCESSING )
		    {
		    	if( diagnosticcp != NULLCP )			
		    	    sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid processing token in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"", "Invalid processing token in", leftToken, rightToken ) ;
#endif
		    }
		    else bulkLoadConfig.configErrorProcReq[ tokenIndex ] = rightValue ;
#ifdef BLT_DEBUG
fprintf( stderr, "Error token has right value = %d\n", rightValue ) ;
#endif
	    	    tokenProcessed = TRUE ;
		}
	    }
	}

	if( tokenProcessed == FALSE )
	{
	    /*                   leftToken 	rightToken
             *
	     * checkAttrTypeForDeleteEntry	userClass
	     *
	     *        periodBeforeDeletion	1styrcog:14
	     */
	    
	    if( strcasecmp( leftToken, "checkAttrTypeForDeleteEntry" ) == 0 )
	    {
	    	bulkLoadConfig.checkAttrTypeForDeleteEntry = str2AttrT( rightToken ) ;
	    	tokenProcessed = TRUE ;
	    }
	    else if( strcasecmp( leftToken, "periodBeforeDeletion" ) == 0 )
	    {
		if( bulkLoadConfig.lastUsedPeriodBeforeDeleteToken >= (CONFIGNUMPERIODBEFOREDELTOKENS - 1) )
		{
		    if( diagnosticcp != NULLCP )
			sprintf( diagnosticcp, "%s %d %s \"%s : %s\"", "Maximum token count of", 
				CONFIGNUMPERIODBEFOREDELTOKENS, "exceeded for", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Maximum token count exceeded for", leftToken, rightToken ) ;
#endif
		}
		else
		{
		    if( bulkLoadConfig.checkAttrTypeForDeleteEntry == NULLAttrT )
		    {
		    	if( diagnosticcp != NULLCP )
			    sprintf( diagnosticcp, "%s \"%s : %s\"", "Missing \"checkAttrTypeForDeleteEntry\" before", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Missing \"checkAttrTypeForDeleteEntry\" before", leftToken, rightToken ) ;
#endif
		    }
		    else if( (coloncp = strchr( rightToken, ':' )) == NULLCP )
		    {
		    	if( diagnosticcp != NULLCP )
			    sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid format in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Missing rightmost colon", leftToken, rightToken ) ;
#endif
		    }
		    else
		    {
			tokenIndex = ++(bulkLoadConfig.lastUsedPeriodBeforeDeleteToken) ;

			*coloncp = '\0' ; /* ..Divide the right token in two */
			
			if( (bulkLoadConfig.periodBeforeDeletionAttrV[ tokenIndex ]=
		    		str2AttrV( rightToken,
				    bulkLoadConfig.checkAttrTypeForDeleteEntry -> oa_syntax )) == NULLAttrV )
		    	{
			    --(bulkLoadConfig.lastUsedPeriodBeforeDeleteToken) ;
		    
		    	    if( diagnosticcp != NULLCP )
			    	sprintf( diagnosticcp, "%s \"%s : %s\"", "Could not encode attribute value in \"checkAttrTypeForDeleteEntry\" before", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Could not encode attribute value in \"checkAttrTypeForDeleteEntry\"", leftToken, rightToken ) ;
#endif
			}
			else
			{
			    /* Now obtain the numeric period before deletion.. */
			    if( strncasecmp( coloncp + 1, "NOLIMIT", 4 ) == 0 )
			    	bulkLoadConfig.periodBeforeDeletionForAttrV[ tokenIndex ] = CONFIGNOLIMITPERIODBEFOREDEL ;
			    else
			    {
			    	if( (bulkLoadConfig.periodBeforeDeletionForAttrV[ tokenIndex ] = atoi( coloncp+1 )) <= 0 )
				{
				    --bulkLoadConfig.lastUsedPeriodBeforeDeleteToken ;

				    if( diagnosticcp != NULLCP )
			    		sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid numeric period in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid numeric period in", leftToken, rightToken ) ;
#endif
				}
			    }
			}
		    }

		}
		
	    	tokenProcessed = TRUE ;
	    }
	}
	
	if( tokenProcessed == FALSE )
	{
	    if( diagnosticcp != NULLCP )
		sprintf( diagnosticcp, "%s \"%s : %s\"", "Invalid left token in", leftToken, rightToken ) ;
#ifdef BLT_DEBUG
else fprintf( stderr, "%s \"%s : %s\"\n", "Invalid left token in", leftToken, rightToken ) ;
#endif
	}	
	
	return( tokenProcessed ) ;
}

void
outputSourceReportParams( paramOutfp )
FILE *  paramOutfp ;
{
char	tmpFileName[ SMALLBUFLEN ], *tmpFilecp ;

	fprintf( paramOutfp, "#		Source Report Parameter Input\n\n\n" ) ;

	fprintf( paramOutfp, "RETURN TO MENU\t: NO\n\n" ) ;

	fprintf( paramOutfp, "Sub-tree parent DN\t: \"%s\"\n\n", 
		(managementConfig.sourceReportSubTreeParentDNcp != NULLCP) ? managementConfig.sourceReportSubTreeParentDNcp : 
		(managementConfig.defaultDNcp != NULLCP ? managementConfig.defaultDNcp : "" ) ) ;

/*	fprintf( paramOutfp, "Number of levels to search : %d\n\n", managementConfig.sourceReportLevels ) ;*/

	strcpy( tmpFileName, "bulkLoadSourceReportXX" ) ;

	tmpFilecp = mktemp( tmpFileName ) ;

	fprintf( paramOutfp, "Output file name\t: %s\n\n", 
		 	(tmpFilecp != NULLCP ? tmpFilecp : "bulkLoadSourceReport")) ;

	return ;
}

void
outputExpiredEntriesParams( paramOutfp )
FILE *  paramOutfp ;
{
char	tmpFileName[ SMALLBUFLEN ], * tmpFilecp, * UTCcp = NULLCP ;
struct 	timeval  t,  *tp  = &t ;
struct	timezone tz, *tzp = &tz ;
struct	tm * tmp ;
UTCtime	utc, * utcp = &utc ;

	fprintf( paramOutfp, "#		Expired Entry Parameter Input\n\n\n" ) ;

	fprintf( paramOutfp, "RETURN TO MENU\t: NO\n\n" ) ;

	fprintf( paramOutfp, "# Note: the user will be prompted to confirm the deletion of any \"expired\" entries\n\n" ) ;

	fprintf( paramOutfp, "Sub-tree parent DN\t: \"%s\"\n\n", 
		(managementConfig.expiredEntriesSubTreeParentDNcp != NULLCP) ? managementConfig.expiredEntriesSubTreeParentDNcp : 
		(managementConfig.defaultDNcp != NULLCP ? managementConfig.defaultDNcp : "" ) ) ;

	strcpy( tmpFileName, "bulkLoadDeleteEntriesXX" ) ;

	tmpFilecp = mktemp( tmpFileName ) ;

	fprintf( paramOutfp, "Output file name\t: %s\n\n", 
		(tmpFilecp != NULLCP ? tmpFilecp : "bulkLoadDeleteEntries") ) ;

	if( managementConfig.expiredEntriesUTCtimecp != NULLCP )
	{
	    (void)free( managementConfig.expiredEntriesUTCtimecp ) ;
	    managementConfig.expiredEntriesUTCtimecp = NULLCP ;
	}

	if( !gettimeofday( tp, tzp) )
	{
	    tmp = localtime( &((time_t)(tp -> tv_sec)) ) ;
	    tm2ut( tmp, utcp ) ;
	    UTCcp = time2str( utcp, 0 ) ;
	}

	fprintf( paramOutfp, "Entry expiry date\t: %s\n\n", (UTCcp != NULLCP ) ? UTCcp : "REPLACE WITH A UTC TIME" ) ;

	return ;
}

void
outputDumpSubtreeParams( paramOutfp )
FILE *  paramOutfp ;
{
char	tmpFileName[ SMALLBUFLEN ], *tmpFilecp ;

	fprintf( paramOutfp, "#		Dump Subtree Parameter Input\n\n\n" ) ;

	fprintf( paramOutfp, "RETURN TO MENU\t: NO\n\n" ) ;

	fprintf( paramOutfp, "Sub-tree parent DN\t: \"%s\"\n\n", 
		(managementConfig.dumpSubtreeSubTreeParentDNcp != NULLCP) ? managementConfig.dumpSubtreeSubTreeParentDNcp : 
		(managementConfig.defaultDNcp != NULLCP ? managementConfig.defaultDNcp : "" ) ) ;

	strcpy( tmpFileName, "bulkLoadDumpSubtreeXX" ) ;

	tmpFilecp = mktemp( tmpFileName ) ;

	fprintf( paramOutfp, "Output file name\t: %s\n\n", 
		(tmpFilecp != NULLCP ? tmpFilecp : "bulkLoadSourceReport")) ;

	return ;
}

void
outputAddValueToSubtreeParams( paramOutfp )
FILE *  paramOutfp ;
{
char *	atcp = NULLCP, * avcp = NULLCP ;

	fprintf( paramOutfp, "#		Add Value To Subtree Nodes Parameter Input\n\n\n" ) ;

	fprintf( paramOutfp, "RETURN TO MENU\t: NO\n\n" ) ;

	fprintf( paramOutfp, "Sub-tree parent DN\t: \"%s\"\n\n", 
		(managementConfig.addValueToSubTreeParentDNcp != NULLCP) ? managementConfig.addValueToSubTreeParentDNcp : 
		(managementConfig.defaultDNcp != NULLCP ? managementConfig.defaultDNcp : "" ) ) ;


	fprintf( paramOutfp, "Add value to just the leaf nodes\t: %s\n\n", 
		(managementConfig.addValueToJustLeafNodes == TRUE) ? "YES" : "NO" ) ;


	if( managementConfig.addValueToSubTreeAt != NULLAttrT )
	    atcp = AttrT2pstr( managementConfig.addValueToSubTreeAt ) ;

	fprintf( paramOutfp, "# E.g. objectClass..\n" ) ;
	fprintf( paramOutfp, "Attribute Type\t: %s\n\n", (atcp != NULLCP) ? atcp : "" ) ;

	if( atcp != NULLCP )
	    (void)free( atcp ) ;

	if( managementConfig.addValueToSubTreeAv != NULLAttrV )
	    avcp = AttrV2pstr( managementConfig.addValueToSubTreeAv ) ;

	fprintf( paramOutfp, "# E.g. bulkDataEntryDetails..\n" ) ;
	fprintf( paramOutfp, "Attribute Value\t: %s\n\n", (avcp != NULLCP) ? avcp : "" ) ;

	if( avcp != NULLCP )
	    (void)free( avcp ) ;

	return ;
}



void
outputResetValidCheckAtParams( paramOutfp )
FILE *  paramOutfp ;
{
char	tmpFileName[ SMALLBUFLEN ], * tmpFilecp, * UTCcp = NULLCP ;
struct 	timeval  t,  *tp  = &t ;
struct	timezone tz, *tzp = &tz ;
struct	tm * tmp ;
UTCtime	utc, * utcp = &utc ;

	fprintf( paramOutfp, "#		Reset Validation Check At Parameter Input\n\n\n" ) ;

	fprintf( paramOutfp, "RETURN TO MENU\t: NO\n\n" ) ;

	fprintf( paramOutfp, "Sub-tree parent DN\t: \"%s\"\n\n", 
		(managementConfig.resetValidChkAtSubTreeParentDNcp != NULLCP) ? managementConfig.resetValidChkAtSubTreeParentDNcp : 
		(managementConfig.defaultDNcp != NULLCP ? managementConfig.defaultDNcp : "" ) ) ;

	strcpy( tmpFileName, "bulkLoadResetValidChkAtXX" ) ;

	tmpFilecp = mktemp( tmpFileName ) ;

	fprintf( paramOutfp, "Output file name\t: %s\n\n", 
		(tmpFilecp != NULLCP ? tmpFilecp : "bulkLoadResetValiChkAt") ) ;

	if( managementConfig.resetValidChkAtUTCtimecp != NULLCP )
	{
	    (void)free( managementConfig.resetValidChkAtUTCtimecp ) ;
	    managementConfig.resetValidChkAtUTCtimecp = NULLCP ;
	}

	if( !gettimeofday( tp, tzp) )
	{
	    tmp = localtime( &((time_t)(tp -> tv_sec)) ) ;
	    tm2ut( tmp, utcp ) ;
	    UTCcp = time2str( utcp, 0 ) ;
	}

	fprintf( paramOutfp, "Reset validationCheckAt time\t: %s\n\n", (UTCcp != NULLCP ) ? UTCcp : "REPLACE WITH A UTC TIME" ) ;

	return ;
}


void
outputSourceValidationParams( paramOutfp )
FILE *  paramOutfp ;
{
	fprintf( paramOutfp, "#		Source Validation Parameter Input\n\n\n" ) ;

	fprintf( paramOutfp, "RETURN TO MENU\t: NO\n\n" ) ;

	fprintf( paramOutfp, "# The file containing the dmformat of a complete data source\n\n" ) ;
	fprintf( paramOutfp, "Input file name\t: \n\n" ) ;

	fprintf( paramOutfp, "# The output will be written to filename.done and filename.PROBLEM\n\n" ) ;

	return ;
}


void
outputCheckValidCheckAtParams( paramOutfp )
FILE *  paramOutfp ;
{
char 	tmpFileName[ SMALLBUFLEN ], *tmpFilecp, * UTCcp ;

	fprintf( paramOutfp, "#		Check Validation Check At Parameter Input\n\n\n" ) ;

	fprintf( paramOutfp, "RETURN TO MENU\t: NO\n\n" ) ;

	fprintf( paramOutfp, "Sub-tree parent DN\t: \"%s\"\n\n", 
		(managementConfig.checkValidChkAtSubTreeParentDNcp != NULLCP) ? managementConfig.checkValidChkAtSubTreeParentDNcp : 
		(managementConfig.defaultDNcp != NULLCP ? managementConfig.defaultDNcp : "" ) ) ;

	strcpy( tmpFileName, "bulkLoadCheckValidChkAtLogXX" ) ;

	tmpFilecp = mktemp( tmpFileName ) ;

	fprintf( paramOutfp, "Output file name\t: %s\n\n", 
		(tmpFilecp != NULLCP ? tmpFilecp : "bulkLoadCheckValidChkAtLog")) ;

	/* 
	 * Attempt to get the UTC time from the one used within the reset check at operation..
	 */
	UTCcp = managementConfig.resetValidChkAtUTCtimecp ;

	if( UTCcp == NULLCP )
	{
	    fprintf( paramOutfp, "# The time the \"validationCheckAt\" values were reset to is unavailable\n" ) ;
	    fprintf( paramOutfp, "# please enter it in the UTC format e.g. yymmddhhmmssZ..\n" ) ;
	}

	fprintf( paramOutfp, "Check validationCheckAt time\t: %s\n\n", (UTCcp != NULLCP ) ? UTCcp : "REPLACE WITH A UTC TIME" ) ;

	return ;
}

void
outputMasterUpAtforNonMasterUpAtParams( paramOutfp )
FILE *  paramOutfp ;
{
char 	tmpFileName[ SMALLBUFLEN ], *tmpFilecp ;

	fprintf( paramOutfp, "#		Replace \"masterUpdatedAttrType\" Parameter Input\n\n\n" ) ;

	fprintf( paramOutfp, "RETURN TO MENU\t: NO\n\n" ) ;

	fprintf( paramOutfp, "Sub-tree parent DN\t: \"%s\"\n\n",
		(managementConfig.masterUpAtToNonMasterSubTreeParentDNcp != NULLCP) ? managementConfig.masterUpAtToNonMasterSubTreeParentDNcp : 
		(managementConfig.defaultDNcp != NULLCP ? managementConfig.defaultDNcp : "" ) ) ;

	strcpy( tmpFileName, "bulkLoadReplaceMasterUpAtLogXX" ) ;

	tmpFilecp = mktemp( tmpFileName ) ;

	fprintf( paramOutfp, "Output file name\t: %s\n\n", 
		(tmpFilecp != NULLCP ? tmpFilecp : "bulkLoadReplaceMasterUpAtLog")) ;
	/*
	 * Mode required..
	 */
	fprintf( paramOutfp, "# For those sub-tree entries that currently contain a\n" ) ;
	fprintf( paramOutfp, "# \"masterUpdatedAttrType\" attribute...\n" ) ;
	fprintf( paramOutfp, "#\n" ) ;
	fprintf( paramOutfp, "# If you require the \"masterUpdatedAttrType\" attribute to be Exchanged with\n" );
	fprintf( paramOutfp, "# a \"nonMasterUpdatedAttrType\", whose values are comprised of those attribute\n" ) ;
	fprintf( paramOutfp, "# types currently held within a Directory entry that are not listed within\n" ) ;
	fprintf( paramOutfp, "# the \"masterUpdatedAttrType\", then specify E.\n" ) ;
	
	fprintf( paramOutfp, "# NOTE 1): The Exchange should only be used if BULKLOAD loaded the sub-tree entries.\n" ) ;
	fprintf( paramOutfp, "# NOTE 2): The bulk attributes plus \"acl\", \"lastModifiedBy\" and \n" ) ;
	fprintf( paramOutfp, "# \"lastModifiedTime\" will not be loaded to the \"nonMasterUpdatedAttrType\" attribute.\n" ) ;

	
	fprintf( paramOutfp, "# \n" ) ;
	fprintf( paramOutfp, "# If you require the \"masterUpdatedAttrType\" to merely be Removed from\n" ) ;	
	fprintf( paramOutfp, "# the directory sub-tree then specify R.\n\n" ) ;

	fprintf( paramOutfp, "Exchange or Remove\t:\n" ) ;

	return ;
}

void
outputCheckDNParams( paramOutfp )
FILE *  paramOutfp ;
{
struct  checkDNAttrTNode * currCheckDNAttrTNodep = managementConfig.checkDNAttrTs ;
char 	tmpFileName[ SMALLBUFLEN ], *tmpFilecp, *atcp ;
int	checkDNcount=0 ;

	fprintf( paramOutfp, "#\tCheck the integrity of Distinguished Name (DN) attribute types : Parameter Input\n" ) ;
	fprintf( paramOutfp, "#\n" ) ;
	fprintf( paramOutfp, "# A subtree search will be performed below the specified parent DN\n" ) ;
	fprintf( paramOutfp, "# to retrieve all of the listed DN attributes. An integrity check will\n" ) ;
	fprintf( paramOutfp, "# then be performed on these DN values to determine whether they still reference\n" ) ;
	fprintf( paramOutfp, "# a current directory entry.\n" );
	fprintf( paramOutfp, "# A report file will then be produced.\n" ) ;
	fprintf( paramOutfp, "# After review the report file may then be fed into \"bulkload\" to\n" ) ;
	fprintf( paramOutfp, "# correct any DN integrity check failures.\n\n" ) ;

	fprintf( paramOutfp, "RETURN TO MENU\t: NO\n\n" ) ;

	fprintf( paramOutfp, "Sub-tree parent DN\t: \"%s\"\n\n",
		(managementConfig.checkDNSubTreeParentDNcp != NULLCP) ? managementConfig.checkDNSubTreeParentDNcp : 
		(managementConfig.defaultDNcp != NULLCP ? managementConfig.defaultDNcp : "" ) ) ;

	strcpy( tmpFileName, "bulkLoadCheckDNattrsLogXX" ) ;

	tmpFilecp = mktemp( tmpFileName ) ;

	fprintf( paramOutfp, "Output file name\t: %s\n\n", 
		(tmpFilecp != NULLCP ? tmpFilecp : "bulkLoadCheckDNattrsLog")) ;

	/*
	 * List the attribute types that are already specified...
	 */

	while( currCheckDNAttrTNodep != NULLCHKDNNODE ) {

	    if( currCheckDNAttrTNodep->checkDNAttrT != NULLAttrT &&
		(atcp = AttrT2pstr( currCheckDNAttrTNodep->checkDNAttrT )) != NULLCP ) {

		fprintf( paramOutfp, "Check DN AttrT : %s\n", atcp ) ;
		(void)free( atcp ) ;

	    	++checkDNcount ;
	    }

	    currCheckDNAttrTNodep = currCheckDNAttrTNodep -> nextCheckDNAttrTNode ;
	}

	/* Did we list any DN attribute types... ? */
	fprintf( paramOutfp, "%s", ( checkDNcount > 0 ) ? "" : "#Check DN AttrT : NONE LISTED IN bulkloadtailor FILE" ) ;

	return ;
}


void
outputRoleOccXrefParams( paramOutfp )
FILE *  paramOutfp ;
{
char 	tmpFileName[ SMALLBUFLEN ], *tmpFilecp ;

	fprintf( paramOutfp, "#\tCross reference \"seeAlso\" attributes with \"roleOccupant\"s : Parameter Input\n" ) ;
	fprintf( paramOutfp, "#\n" ) ;
	fprintf( paramOutfp, "#NOTE: it is strongly recommended that function %d be run on the required sub-tree first\n", MENUOPTCHKDNS ) ;
	fprintf( paramOutfp, "#\n" ) ;
	fprintf( paramOutfp, "# A subtree search will be performed below the specified parent DN\n" ) ;
	fprintf( paramOutfp, "# to retrieve \"roleOccupant\" attributes. A check will then be performed\n" ) ;
	fprintf( paramOutfp, "# to determine whether each directory entry that is specified by a\n" ) ;
	fprintf( paramOutfp, "# \"roleOccupant\" attribute contains a \"seeAlso\" attribute cross reference.\n" ) ;
	fprintf( paramOutfp, "# If it does not then the report file output will contain a request for the\n" ) ;
	fprintf( paramOutfp, "# attribute to be added.\n" ) ;
	fprintf( paramOutfp, "#\n" ) ;
	fprintf( paramOutfp, "# After review the report file may then be fed into \"bulkload\" to\n" ) ;
	fprintf( paramOutfp, "# achieve the insertions of the required \"seeAlso\" attributes.\n\n" ) ;

	fprintf( paramOutfp, "RETURN TO MENU\t: NO\n\n" ) ;

	fprintf( paramOutfp, "Sub-tree parent DN\t: \"%s\"\n\n",
		(managementConfig.roleOccXrefSubTreeParentDNcp != NULLCP) ? managementConfig.roleOccXrefSubTreeParentDNcp : 
		(managementConfig.defaultDNcp != NULLCP ? managementConfig.defaultDNcp : "" ) ) ;

	strcpy( tmpFileName, "bulkLoadRoleOccXrefLogXX" ) ;

	tmpFilecp = mktemp( tmpFileName ) ;

	fprintf( paramOutfp, "Output file name\t: %s\n\n", 
		(tmpFilecp != NULLCP ? tmpFilecp : "bulkLoadRoleOccXrefLog")) ;

	return ;
}


void
outputManagementConfigToFile( configFilep )
FILE *	configFilep ;
{
char *	atcp ;
struct  checkDNAttrTNode * currCheckDNAttrTNodep = managementConfig.checkDNAttrTs ;
int	checkDNcount = 0 ;

	/* Default DN (management operations) */
	fprintf( configFilep, "\n# The default distinguished name for management operations\n#\n" ) ;

	fprintf( configFilep, "default DN	:	\"%s\"\n\n", ( managementConfig.defaultDNcp != NULLCP ) ?
									managementConfig.defaultDNcp : "" ) ;

	/* The check distinguished name attribute types... */
	while( currCheckDNAttrTNodep != NULLCHKDNNODE ) {

	    if( currCheckDNAttrTNodep->checkDNAttrT != NULLAttrT &&
		(atcp = AttrT2pstr( currCheckDNAttrTNodep->checkDNAttrT )) != NULLCP ) {

		fprintf( configFilep, "Check DN AttrT : %s\n", atcp ) ;
		(void)free( atcp ) ;
	    	++checkDNcount ;
	    }

	    currCheckDNAttrTNodep = currCheckDNAttrTNodep -> nextCheckDNAttrTNode ;
	}

	/* Did we list any DN attribute types... ? */
	fprintf( configFilep, "%s", ( checkDNcount > 0 ) ? "\n\n" : "#Check DN AttrT : NONE LISTED IN bulkloadtailor FILE\n\n" ) ;

	return ;
}


void
outputBulkLoadConfigToFile( configFilep )
FILE *	configFilep ;
{
int	configIndex, titleIndex, attrTindex ;
char *	cp, *avcp, * atcp ;
struct	autoInsertNode		 * currAutoInsertNodep ;
struct	autoInsertObjClsListNode * currAutoInsertObjClsListNodep ;
struct	uniqueKeyNode		 * currUniqueKeyNodep ;


	fprintf( configFilep, "#\n# Please review the current configuration settings\n#\n" ) ;
	fprintf( configFilep, "# Note: THE SETTINGS WILL NOT BE STORED TO \"bulkloadtailor\"\n#\n" ) ;
	fprintf( configFilep, "# On an error condition search for \"#ERROR\"\n#\n" ) ;
	
	/* 
	 * transfer the current configuration to the draft file
	 */

	/* error processing configuration.. */

	fprintf( configFilep, "#\n# When an error occurs the respective update may be routed to one of\n#\n#	1) the NOACTION required file\n\
#	2) the PROBLEMs file\n#	3) for interactive PROCESSing\n#\n\
# Note: this applies for both the interactive and the\n# non-interactive operational modes\n#\n" ) ;

	    
	for( configIndex = 0 ; configIndex < NUMCONFIGERRORTYPES ; configIndex++ )
	{
	    fprintf( configFilep, "%s\t\t: %s\n", configErrorDisplayTokens[ configIndex ],
				processFileTokens[ bulkLoadConfig.configErrorProcReq[ configIndex ] ] ) ;
	}

	fprintf( configFilep, "\n\n" ) ;


	/* dataSource search levels.. */

	fprintf( configFilep, "#\n# Indicate the highest directory level in a rootedAt DN that should be\n\
# searched for \"dataSource\" entries, to retrieve the master and delete source details.\n\
#\n\
# E.g. for \"rootedAt=c=GB@o=University College London@ou=Computer Science\"\n\
#\n\
# a value of \"3\" will permit searches solely within :-\n\
#	\"c=GB@o=University College London@ou=Computer Science\"\n\
#\n\
# whilst a value of \"2\" permits searches within :-\n\
#	\"c=GB@o=University College London@ou=Computer Science\" and\n\
#	\"c=GB@o=University College London\"\n\
#\n" );

	fprintf( configFilep, "Highest directory level to search for dataSource entries : %d\n\n",
					bulkLoadConfig.highestDataSourceSearchLevel ) ;

	/* mastering by all source of certain attribute types.. */

	fprintf( configFilep, "#\n# List those attribute types that have all data sources as their masters\n\
# irrespective of the mastering details within \"dataSource\" entries or\n\
# the setting of \"When no master specified for a type all sources are masters\".\n#\n" ) ;


	for( attrTindex = 0 ; attrTindex <= bulkLoadConfig.lastUsedAttrTIndex ; attrTindex++ )
	{
	    if( bulkLoadConfig.allSourcesAreMastersForAttrT[ attrTindex ] != NULLAttrT &&
	    	(atcp = AttrT2pstr( bulkLoadConfig.allSourcesAreMastersForAttrT[ attrTindex ] )) != NULLCP )
	    {
	    	fprintf( configFilep, "All sources are masters for : %s\n", atcp ) ;
		(void)free( atcp ) ;
	    }
	}
	
	fprintf( configFilep, "\n" ) ;

	/* value clear down when master source adds its first value.. */

	fprintf( configFilep, "#\n# Any existing values for an attribute may be cleared down when a master source\n\
# adds a value to the attribute for the first time (i.e. the attribute type\n\
# is not already listed in the entry's \"masterUpdatedAttrType\" attribute).\n#\n" ) ;

	fprintf( configFilep, "Existing attr value may be cleared if master source applies 1st value : %s\n\n",
				(bulkLoadConfig.valueClearDownPermittedOnFirstMasterUpdate == TRUE) ? "YES" : "NO" ) ;

	fprintf( configFilep, "\n" ) ;

	
	/* mastering in the absence of dataSource master specifications.. */

	fprintf( configFilep, "#\n# If the \"dataSource\" entries found within the scope defined by the\n\
# \"Highest directory level to search\" and the Distinguished Name within\n\
# a \"rootedAt\" statement do not specify a single master source for a given\n\
# attribute type then this configuration statement determines whether all\n\
# data sources are treated as the attribute type`s master source\n\
# (or none of them are).\n#\n" );

	fprintf( configFilep, "When no master specified for a type all sources are masters : %s\n\n",
				(bulkLoadConfig.noMasterSpecifiedSoAllSourcesAreMasters == TRUE) ? "YES" : "NO" ) ;

	/* Create sources.. */
	
	fprintf( configFilep, "#\n# Specify that all data sources are permitted to create entries\n\
# whether there is a dataSource entry that permits them to or not.\n#\n" ) ;

	fprintf( configFilep, "All sources are create sources : %s\n\n",
				(bulkLoadConfig.allSourcesAreCreateSources == TRUE) ? "YES" : "NO" ) ;
					

	/* Add entry converted to add attributes.. */

	fprintf( configFilep, "#\n# It may well be the case that the same entry is requested to be added by \n\
# more than one data source. If the entry already exists we can request that\n\
# an attempt is made to add the attributes contained in the add entry request.\n\
# This will be applied only if we match with exactly one existing entry.\n\
# Whether an entry is found depends on which matching algorithm you choose.\n#\n" ) ;

	fprintf( configFilep, "Auto convert add entry to add attributes if entry already exists : %s\n\n",
				(bulkLoadConfig.autoAddEntryToAddAttrIfExists == TRUE) ? "YES" : "NO" ) ;
					

	/* personalTitle configuration.. */

	fprintf( configFilep, "#\n# personalTitle gender specifications into MALE, FEMALE, HUMAN or NONHUMAN\n#\n" );

	    
	for( titleIndex = 0 ; titleIndex < NUMCONFIGTITLETYPES ; titleIndex++ )
	{
	    for( configIndex = 0 ; configIndex <= bulkLoadConfig.lastUsedTitlesToken[ titleIndex ] ; configIndex++ )
	    {
		if( (cp = bulkLoadConfig.titleTokenscp[ titleIndex ][ configIndex ]) != NULLCP )
		    fprintf( configFilep, "%s\t: %s\n", configTitleTokens[ titleIndex ], cp ) ;
	    }
	}


	/* auto object class insertion configuration.. */
	fprintf( configFilep, "\n#\n# Auto insertion of missing object classes\n#\n\
# autoInsertOnAttrT -	If an add entry request has this attribute type then check\n\
#			for the \"autoInsertOnAttrV\" value.\n\
# autoInsertOnAttrV -	If the add entry \"autoInsertOnAttrT\" type has this \n\
#			attribute value then insert the \"autoInsertObjCls\" classes.\n\
# autoInsertObjCls  -	Multiple statements containing the object classes to be inserted\n\
#			(if missing) within an add entry request.\n#\n" ) ;

	currAutoInsertNodep = bulkLoadConfig.autoInsertNodep ;

	while( currAutoInsertNodep != NULLAUTOINSERTNODE )
	{
	    if( currAutoInsertNodep->autoInsertOnAttrT != NULLAttrT &&
	    	(atcp = AttrT2pstr( currAutoInsertNodep->autoInsertOnAttrT )) != NULLCP )
	    {
	    	fprintf( configFilep, "\nautoInsertOnAttrT	:	%s\n", atcp ) ;
		(void)free( atcp ) ;

	    	if( currAutoInsertNodep->autoInsertOnAttrV != NULLAttrV &&
		    (avcp = AttrV2pstr( currAutoInsertNodep->autoInsertOnAttrV )) != NULLCP )
		{
		    fprintf( configFilep, "autoInsertOnAttrV	:	%s\n", avcp ) ;
		    (void)free( avcp ) ;

		    currAutoInsertObjClsListNodep = currAutoInsertNodep -> autoInsertObjClsListp ;

		    while( currAutoInsertObjClsListNodep != NULLAUTOINSERTOBJCLSLIST )
		    {
		    	if( currAutoInsertObjClsListNodep->autoInsertObjClsAttrV != NULLAttrV &&
			    (avcp = AttrV2pstr( currAutoInsertObjClsListNodep->autoInsertObjClsAttrV )) != NULLCP )
			{
			    fprintf( configFilep, "autoInsertObjCls	:	%s\n", avcp ) ;
			    (void)free( avcp ) ;
			}
		
	    		currAutoInsertObjClsListNodep = currAutoInsertObjClsListNodep -> nextAutoInsertObjClsListNodep ;
	    	    }
		}
	    }

	    currAutoInsertNodep = currAutoInsertNodep -> nextAutoInsertNodep ;		
	}
	

	/* delete entry after configuration.. */
	fprintf( configFilep, "\n#\n# deleteEntryAfter configuration\n#\n\
# checkAttrTypeForDeleteEntry - indicates the entry attribute that\n\
#				shall be checked to determine the setting of\n\
#				\"deleteEntryAfter\"\n#\n\
# periodBeforeDeletion - indicates the number of MONTHS to be added to the current date\n\
#			 for an entry of the specified class as held in the attribute\n\
#			 given by \"checkAttrTypeForDeleteEntry\"\n#\n\n" ) ;

	if( bulkLoadConfig.checkAttrTypeForDeleteEntry != NULLAttrT &&
	    (atcp = AttrT2pstr( bulkLoadConfig.checkAttrTypeForDeleteEntry )) != NULLCP )
	{
	    fprintf( configFilep, "%s : %s\n\n", "checkAttrTypeForDeleteEntry", atcp ) ;
	    (void)free( atcp ) ;

	    for( configIndex = 0 ; configIndex <= bulkLoadConfig.lastUsedPeriodBeforeDeleteToken ; configIndex++ )
	    {
	    	if( bulkLoadConfig.periodBeforeDeletionAttrV[ configIndex ] != NULLAttrV &&
		    (avcp = AttrV2pstr( bulkLoadConfig.periodBeforeDeletionAttrV[ configIndex ] )) != NULLCP )
		{		
	    	    if (bulkLoadConfig.periodBeforeDeletionForAttrV[ configIndex ] == CONFIGNOLIMITPERIODBEFOREDEL )
		        fprintf( configFilep, "%s : %s : %s\n", "periodBeforeDeletion", avcp, "NOLIMIT" ) ;
	    	    else
		        fprintf( configFilep, "%s : %s : %d\n", "periodBeforeDeletion", avcp, bulkLoadConfig.periodBeforeDeletionForAttrV[ configIndex ] ) ;

	    	    (void)free( avcp ) ;
		}
	    }
	}

	/* Full stop cn delimiter replacement.. */

	fprintf( configFilep, "\n#\n# If you require an input commonName of \"cn=F.A.Bloggs\" to be\n\
# presented to the Directory as \"cn=F A Bloggs\" then state \"YES\",\n\
# else \"NO\".\n#\n" ) ;

	fprintf( configFilep, "Replace full stop commonName delimiters with spaces : %s\n\n",
				(bulkLoadConfig.replaceFullStopCommonNameDelimsWithSpaces == TRUE) ? "YES" : "NO" ) ;

	/* CommonName search format.. */

	fprintf( configFilep, "#\n# Specify the search pattern to be used when searching for\n\
# commonNames. Three strings are currently permitted\n#\n\
# a)	STARINITSTARSPACESURNAMESTAR 	e.g. \"*F* Bloggs*\"\n\
# b)	STARINITSTARSURNAMESTAR 	e.g. \"*F*Bloggs*\"\n\
# c)	STARSURNAMESPACEINITSTAR 	e.g. \"*Bloggs F*\"\n#\n\
# (b) should be used if full-stop delimiters are present in the commonNames\n\
# (c) should be used if the commonNames have the Swiss format e.g. \"Bloggs Fred I.\"\n#\n" ) ;

	fprintf( configFilep, "CommonName search format : %s\n\n",
				(bulkLoadConfig.commonNameSearchFormat == STARINITSTARSURNAMESTAR) ? 
				"STARINITSTARSURNAMESTAR" :
				(bulkLoadConfig.commonNameSearchFormat == STARSURNAMESPACEINITSTAR) ?
				"STARSURNAMESPACEINITSTAR" : "STARINITSTARSPACESURNAMESTAR" ) ;

	/* DSA log file details.. */
	fprintf( configFilep, "#\n# The resolution of Object class violation errors may well require\n\
# information from a log file. A basic mechanism has been added to\n\
# permit the inclusion of the tail N bytes of the specified log file\n\
# within the corresponding error edit buffer.\n#\n" ) ;

	fprintf( configFilep, "DSA error log file name    : %s\n",
		(bulkLoadConfig.dsaErrorLogFileNamecp == NULLCP) ? "" : bulkLoadConfig.dsaErrorLogFileNamecp ) ;

	fprintf( configFilep, "DSA error log tail N bytes : %d\n\n", bulkLoadConfig.dsaErrorLogTailNBytes ) ;

	/* Unique key attribute type configuration.. */
	fprintf( configFilep, "\n#\n# If entries within your data sources are uniquely identified by the value of\n\
# certain attribute type(s) then list them here in a list of \"Unique key attrT : X\"\n\
# statements.\n#\n" ) ;

	currUniqueKeyNodep = bulkLoadConfig.uniqueKeyNodep ;

	while( currUniqueKeyNodep != NULLUNIQUEKEYNODE )
	{
	    if( currUniqueKeyNodep->uniqueKeyAttrT != NULLAttrT &&
	    	(atcp = AttrT2pstr( currUniqueKeyNodep->uniqueKeyAttrT )) != NULLCP )
	    {
	    	fprintf( configFilep, "Unique key attrT	:	%s\n", atcp ) ;
		(void)free( atcp ) ;
	    }

	    currUniqueKeyNodep = currUniqueKeyNodep -> nextUniqueKeyNodep ;		
	}

	return ;
}

void
processConfigUpdates( outputConfigToFile, initConfigurations, processConfigLine )
void (*outputConfigToFile)() ;
void (*initConfigurations)() ;
int  (*processConfigLine)()  ;
{
FILE *  configEditFilep = (FILE*)0, *configParseOutputFilep = (FILE*)0 ;

int	editRequired = TRUE, editFileIsConfig1 = TRUE, firstIteration = TRUE ;
char	diagnostics[ SMALLBUFLEN ], configFileLine[ SMALLBUFLEN ] ;
char *	leftTokencp, * rightTokencp, * cp ;
char *	config1Filecp, * config2Filecp, config1FileBuf[ SMALLBUFLEN ], config2FileBuf[ SMALLBUFLEN ] ;

	editRequired = TRUE ;

	sprintf( config1FileBuf, "%sXXXXXX", CONFIG1FILENAME ) ;
	config1Filecp = mktemp( config1FileBuf ) ;

	sprintf( config2FileBuf, "%sXXXXXX", CONFIG2FILENAME ) ;
	config2Filecp = mktemp( config2FileBuf ) ;

	while( editRequired == TRUE )
	{
	    editRequired = FALSE ;

	    if( firstIteration == TRUE &&
	    	(configEditFilep = fopen( config1Filecp, "w" )) == ((FILE *)NULL) )
	    {
	    	perror( "Attempt to open configuation file failed" ) ;
	    }
	    else
	    {
		if( firstIteration == TRUE )
		{
		    /* load the current configuration.. */
	    	    outputConfigToFile( configEditFilep ) ;

		    /* Now allow for the file to be (re-)edited */
		    fclose( configEditFilep ) ;
		}
		/* else the results of a previous edit are already available */
		
		
	    	editFile( (editFileIsConfig1 == TRUE) ? config1Filecp : config2Filecp ) ;

		
		if( (configEditFilep = fopen( (editFileIsConfig1 == TRUE) ? config1Filecp : config2Filecp, "r" )) == NULL ||
		    (configParseOutputFilep = fopen( (editFileIsConfig1 == TRUE) ? config2Filecp : config1Filecp, "w" )) == NULL )
		{
		    perror( "Attempt to open configuation file failed" ) ;
		}
		else
		{
		    /* Free and initialise the configuration table storage */
		
		    initConfigurations( FALSE ) ;
		
		    
		    /* Parse the configuration file's contents */

		    while( (fgets( configFileLine, SMALLBUFLEN, configEditFilep ) != NULL) )
		    {
			if( strncasecmp( configFileLine, "#ERROR", 6 ) != 0 )
			    fprintf( configParseOutputFilep, "%s", configFileLine ) ;
		    
		    	if( *configFileLine != '#' && !isspace( *configFileLine ) )
		    	{
		    	    leftTokencp = configFileLine ;

		    	    if( (cp = strchr( leftTokencp, ':')) == NULLCP )
		    	    {
			    	sprintf( diagnostics, "%s %s", "Missing colon in", configFileLine ) ;
		    	    }
			    else
			    {
			    	*cp = '\0' ;

			    	rightTokencp = cp + 1 ;

		    	    	(void)processConfigLine( leftTokencp, rightTokencp, diagnostics ) ;
			    }

			    if( diagnostics[ 0 ] != '\0' )
			    {
				editRequired = TRUE ;

			    	fprintf( configParseOutputFilep, "#ERROR\n#ERROR *** %s\n#ERROR\n", diagnostics ) ;
				diagnostics[ 0 ] = '\0' ;
			    }
		    	}
		    }

	    	}
	    }
	
	    fclose( configEditFilep  ) ;
	    fclose( configParseOutputFilep ) ;

	    editFileIsConfig1 = (editFileIsConfig1 == TRUE ) ? FALSE : TRUE ;

	    firstIteration = FALSE ;
	}

	unlink( config1Filecp ) ; unlink( config2Filecp ) ;
	
	return ;
}

void
processConfigBulkLoadUpdates()
{
	processConfigUpdates( outputBulkLoadConfigToFile, initBulkLoadConfigurations, processBulkLoadConfigLine ) ;

	return ;
}

void
processConfigManagementUpdates()
{
	processConfigUpdates( outputManagementConfigToFile, initManagementConfigurations, processManagementConfigLine ) ;

	return ;
}

void
processSourceReportUpdates()
{
	processConfigUpdates( outputSourceReportParams, initSourceReportParams, processSourceReportParamLine ) ;

	return ;
}

void
processExpiredEntriesUpdates()
{
	processConfigUpdates( outputExpiredEntriesParams, initExpiredEntriesParams, processExpiredEntriesParamLine ) ;

	return ;
}

void
processDumpSubtreeUpdates()
{
	processConfigUpdates( outputDumpSubtreeParams, initDumpSubtreeParams, processDumpSubtreeParamLine ) ;

	return ;
}

void
processAddValueToSubTreeUpdates()
{
	processConfigUpdates( outputAddValueToSubtreeParams, initAddValueToSubtreeParams, processAddValueToSubtreeParamLine ) ;

	return ;
}

void
processResetValidCheckAtUpdates()
{
	processConfigUpdates( outputResetValidCheckAtParams, initResetValidCheckAtParams, processResetValidCheckAtParamLine ) ;

	return ;
}

void
processSourceValidationUpdates()
{
	processConfigUpdates( outputSourceValidationParams, initSourceValidationParams, processSourceValidationParamLine ) ;

	return ;
}

void
processCheckValidCheckAtUpdates()
{
	processConfigUpdates( outputCheckValidCheckAtParams, initCheckValidCheckAtParams, processCheckValidCheckAtParamLine ) ;

	return ;
}

void
processMasterUpAtforNonMasterUpAtUpdates()
{
	processConfigUpdates( outputMasterUpAtforNonMasterUpAtParams, initMasterUpAtforNonMasterUpAtParams, processMasterUpAtforNonMasterUpAtParamLine ) ;

	return ;
}


void
processCheckDNUpdates()
{
	processConfigUpdates( outputCheckDNParams, initCheckDNParams, processCheckDNParamLine ) ;
	return ;
}

void
processRoleOccXrefUpdates()
{
	processConfigUpdates( outputRoleOccXrefParams, initRoleOccXrefParams, processRoleOccXrefParamLine ) ;
}
