#include <stdio.h>
#include <string.h>

#include <isode/quipu/name.h>

#include "bulkloadglobal.h"
#include "bulkloadattrnames.h"
#include "bulkloaderrors.h"
#include "processandupdate.h"

extern	struct	bulkLoadConfigStruct bulkLoadConfig ;

/* 
 * Edit draft file loop .. 
 */

int
editRAandRDNblock( inFileType, OFD, sourceNamecp, currRAApp, prevRAAp, actionReqp, convAddToValuesPoss,
			overridePossible, overridecp, overruledp, updatesToExistingEntriesp, diagnostics1, diagnostics2 )
int	inFileType ;
struct	outputFileDetails OFD[] ;
char *	sourceNamecp ;
struct	rootedAtAttributes ** currRAApp, /* Node may be modified by the edit updates */
	* prevRAAp ;
int  *	actionReqp ;
int	convAddToValuesPoss, overridePossible ;
char *	overridecp ;
int  *	overruledp, * updatesToExistingEntriesp ;
char *	diagnostics1, * diagnostics2 ; /* Note: diagnostics2 may be a pointer to a Quipu
					  error string and is thus of indeterminant length */
{
int	editResponse, anotherEditRequired, noFurtherProcReq = FALSE /* the return value */ ;
int	requestWasAModRDN = FALSE, processEditAborted = FALSE ;
char	systemCommand[ SMALLBUFLEN ] ;
struct	rootedAtAttributes * savedCurrRAAp ;

	(void)sprintf( systemCommand, "%s%s", "$EDITOR ", OFD[ OUTPUTDRAFTFILE ].outputFilename ) ;

	do {

	    anotherEditRequired = FALSE ;

	    OFD[ OUTPUTDRAFTFILE ].RootedAtOutput = FALSE ;
	    OFD[ OUTPUTDRAFTFILE ].RDNoutput      = FALSE ;

	    if( *actionReqp == MODRDNACTION )
		transferRootedAtModRDN( OFD, OUTPUTDRAFTFILE, *currRAApp, diagnostics1, diagnostics2 ) ;
	    else
		transferRootedAtRDNattrs( OFD, OUTPUTDRAFTFILE, *currRAApp, diagnostics1, diagnostics2 ) ;

	    (void)fclose( OFD[ OUTPUTDRAFTFILE ].outFilep ) ;
	    OFD[ OUTPUTDRAFTFILE ].outFilep = (FILE*)NULL ;

	    do{ 
	    
	    	/* Edit the draft file.. */
	    	(void)system( systemCommand ) ;

	    } while( (editResponse = enterEditResponse( convAddToValuesPoss, FALSE, overridePossible, overridecp, 
								*updatesToExistingEntriesp )) == EDITREEDITFILE ) ;


	    if( (OFD[ OUTPUTDRAFTFILE ].outFilep = fopen( OFD[ OUTPUTDRAFTFILE ].outputFilename, "r" )) == NULL)
	    {
	    	perror( "Attempt to open bulkload draft file failed" ) ;

		(void)strcpy( diagnostics1, "fopen failure on the bulk load draft file" ) ;
		
		if( *actionReqp == MODRDNACTION )
		    transferRootedAtModRDN( OFD, OUTPUTPROBLEMFILE, *currRAApp, diagnostics1, diagnostics2 ) ;
		else
		    transferRootedAtRDNattrs( OFD, OUTPUTPROBLEMFILE, *currRAApp, diagnostics1, diagnostics2 ) ;

	    	de_exit( ERRFILEOPENFAILURE ) ;
	    }
	    else
	    {
	    	if( editResponse == NOTOK ||
		    editResponse == EDITSENDORIGTOPROBLEMSFILE )
	    	{
		    if( *actionReqp == MODRDNACTION )
		    	transferRootedAtModRDN( OFD, OUTPUTPROBLEMFILE, *currRAApp, diagnostics1, diagnostics2 ) ;
		    else
		    	transferRootedAtRDNattrs( OFD, OUTPUTPROBLEMFILE, *currRAApp, diagnostics1, diagnostics2 ) ;
	    	    
		    noFurtherProcReq = TRUE ;
	    	}
		else if( editResponse == EDITSENDORIGTONOACTFILE )
	    	{
		    if( *actionReqp == MODRDNACTION )
			transferRootedAtModRDN( OFD, OUTPUTNOACTIONFILE, *currRAApp, diagnostics1, diagnostics2 ) ;
		    else
			transferRootedAtRDNattrs( OFD, OUTPUTNOACTIONFILE, *currRAApp, diagnostics1, diagnostics2 ) ;
	    	    
		    noFurtherProcReq = TRUE ;
	    	}
		else
		{
		    /* Retrieve data from the file (may cause updates to currRAApp */

	 	    savedCurrRAAp = *currRAApp ; processEditAborted = FALSE ;

		    if( (processRAandRDNEditFile( inFileType, OFD, currRAApp, &processEditAborted ) != OK
		         || *currRAApp == NULL )
			&& (processEditAborted == FALSE) )
		    {
			/* draft file parse failure */
			
			(void)strcpy( diagnostics1, "Fatal error occurred on previous edit" ) ;
			diagnostics2[ 0 ] = '\0' ;

		    	if( *actionReqp == MODRDNACTION )
		    	    transferRootedAtModRDN( OFD, OUTPUTPROBLEMFILE, *currRAApp, diagnostics1, diagnostics2 ) ;
		    	else
		    	    transferRootedAtRDNattrs( OFD, OUTPUTPROBLEMFILE, *currRAApp, diagnostics1, diagnostics2 ) ;

		    	noFurtherProcReq = TRUE ;
		    }
		    else {

			if( processEditAborted == FALSE ) {

			    if( editResponse == EDITDISENABLEMINUSEFORENTRY )
			    {
			    	*updatesToExistingEntriesp = FALSE ;
			    }

			    /* The current RDN and attributes may have been editied.. */

			    /* Link in the new node to the current linked list.. */
			    if( prevRAAp != NULLRAA )
				prevRAAp -> nextRootedAtAttrsp = *currRAApp ;
			
			    (*currRAApp) -> nextRootedAtAttrsp = savedCurrRAAp -> nextRootedAtAttrsp ;

		    	    /* Discard the newly replaced node.. */
			    savedCurrRAAp -> nextRootedAtAttrsp = NULLRAA ;
		    	    freeRootedAtAttrs_list( &savedCurrRAAp ) ;
			    	
			    if( *actionReqp == MODRDNACTION )
			    	requestWasAModRDN = TRUE ;
			    else
			    	requestWasAModRDN = FALSE ;

			    if( determineActionReq( (*currRAApp) -> rdnLinecp, actionReqp, 
					inFileType, TRUE, NULL, *updatesToExistingEntriesp ) != OK )
			    {
			    	/* ..Could not determine the action required */

			    	OFD[ OUTPUTDRAFTFILE ].RootedAtOutput = FALSE ;
			    	OFD[ OUTPUTDRAFTFILE ].RDNoutput      = FALSE ;
			
			    	/* Prepare to redit the old RDN details */

		    	    	(void)strcpy( diagnostics1, "Could not determine action required from the RDN line" ) ;
			    	diagnostics2[ 0 ]   = '\0' ;

			    	anotherEditRequired = TRUE ;

			    } else {

			    	if( requestWasAModRDN == TRUE && (*currRAApp)->modRdn != NULLRDN )
				    *actionReqp = MODRDNACTION ;

			    	if( editResponse == EDITSENDEDITTOPROBLEMSFILE )
		    	    	{
			    	    /* Dump the new RDN details to the PROBLEMs file.. */
			    	    if( *actionReqp == MODRDNACTION )
				    	transferRootedAtModRDN( OFD, OUTPUTPROBLEMFILE, *currRAApp, diagnostics1, diagnostics2 ) ;
			    	    else
				    	transferRootedAtRDNattrs( OFD, OUTPUTPROBLEMFILE, *currRAApp, diagnostics1, diagnostics2 ) ;
			    
	    	    	    	    noFurtherProcReq = TRUE ;
		            	}
		    	    	else if( editResponse == EDITSENDEDITTONOACTFILE )
		    	    	{
			    	    /* Dump the new RDN details to the PROBLEMs file.. */
			    	    if( *actionReqp == MODRDNACTION )
			    	    	transferRootedAtModRDN( OFD, OUTPUTNOACTIONFILE, *currRAApp, diagnostics1, diagnostics2 ) ;
			    	    else
			    	    	transferRootedAtRDNattrs( OFD, OUTPUTNOACTIONFILE, *currRAApp, diagnostics1, diagnostics2 ) ;

	    	    	    	    noFurtherProcReq = TRUE ;
		    	    	}
			    	else if( editResponse == EDITOVERRIDE )
			    	{
			    	    *overruledp = TRUE ;
			    	}
	        	    	else if( editResponse == EDITADDENTRYCONVTOADDVALUES )
	    		    	{
			    	    /* edit loop exit */
			    	    *actionReqp = NOACTIONREQ ;

			    	    /* Note: further processing is needed in the calling procedure since the action 
			    	       required has changed from an Add Entry (which can not correspond to an existing entry),
			    	       to a no action (that is to lead to just the attributes of the entry being added to an
			    	       EXISTING entry) */

			    	    noFurtherProcReq = FALSE ;
				}
		    	    }
		    	    /* no further action for EDITEDITREPROCESS */
			}
		    }
		}

	    	(void)fclose( OFD[ OUTPUTDRAFTFILE ].outFilep ) ; /* ..Previously opened for reading.. */
	    	if( (OFD[ OUTPUTDRAFTFILE ].outFilep = fopen( OFD[ OUTPUTDRAFTFILE ].outputFilename, "w" )) == NULL )
		{
	    	    perror( "Attempt to open bulkload draft file failed" ) ;
		    de_exit( ERRFILEOPENFAILURE ) ;
		}
	    }

	} while( anotherEditRequired == TRUE ) ;

	return( noFurtherProcReq ) ;
}


int
editAttributeSequence( inFileType, OFD, entryRDN, currRAAp )
int	inFileType ;
struct	outputFileDetails OFD[] ;
RDN	entryRDN ;
struct 	rootedAtAttributes * currRAAp ;
{
int	editResponse, anotherEditRequired, noFurtherProcReq = FALSE /* the return value */ ;
char	systemCommand[ SMALLBUFLEN ] ;
struct	attributeLine *  savedBaseALp, ** currALpp, * prevALp ;
struct	attributeLine ** baseALpp, ** nextALpp ;
int	processEditAborted = FALSE ;

	baseALpp = &(currRAAp -> attrLinep) ;

	(void)sprintf( systemCommand, "%s%s", "$EDITOR ", OFD[ OUTPUTDRAFTFILE ].outputFilename ) ;

	do {

	    anotherEditRequired = FALSE ;

	    OFD[ OUTPUTDRAFTFILE ].RootedAtOutput = FALSE ;
	    OFD[ OUTPUTDRAFTFILE ].RDNoutput      = FALSE ;

	    transferRDNattrs( OFD, OUTPUTDRAFTFILE, *baseALpp, "Please correct the following errors", currRAAp -> attrSequenceErrorMsgcp ) ;

	    (void)fclose( OFD[ OUTPUTDRAFTFILE ].outFilep ) ;
	    OFD[ OUTPUTDRAFTFILE ].outFilep = (FILE*)NULL ;

	    /* Edit the draft file.. */
	    do {
	    
	    	(void)system( systemCommand ) ;

	    } while( (editResponse = enterEditResponse( FALSE, TRUE, FALSE, NULLCP, FALSE )) == EDITREEDITFILE ) ; 
	
	    
	    if( (OFD[ OUTPUTDRAFTFILE ].outFilep = fopen( OFD[ OUTPUTDRAFTFILE ].outputFilename, "r" )) == ((FILE *)NULL))
	    {
	    	perror( "Attempt to open bulkload draft file failed" ) ;

		transferRDNattrs( OFD, OUTPUTPROBLEMFILE, *baseALpp, currRAAp -> attrSequenceErrorMsgcp, "fopen failure on the bulk load draft file" ) ;

	    	de_exit( ERRFILEOPENFAILURE ) ;	    	
	    }
	    else if( editResponse == NOTOK ||
		editResponse == EDITSENDORIGTOPROBLEMSFILE )
	    {
		transferRDNattrs( OFD, OUTPUTPROBLEMFILE, *baseALpp, currRAAp -> attrSequenceErrorMsgcp, NULLCP ) ;
	    	noFurtherProcReq = TRUE ;
	    }
	    else if( editResponse == EDITSENDORIGTONOACTFILE )
	    {
		transferRDNattrs( OFD, OUTPUTNOACTIONFILE, *baseALpp, currRAAp -> attrSequenceErrorMsgcp, NULLCP ) ;
	    	noFurtherProcReq = TRUE ;
	    }
	    else if( editResponse == EDITROUTEINDIVATTRS )
	    {
	    	prevALp  = NULLALP ;
		currALpp = baseALpp ;

		(void)fclose( OFD[ OUTPUTDRAFTFILE ].outFilep ) ;
		OFD[ OUTPUTDRAFTFILE ].outFilep = (FILE*)NULL ;
		
		while( currALpp && ((*currALpp) != NULLALP) )
		{
		    /* If the attribute line is affected by a sequence error or a specific
		       error then pass it for indivivdual editing/routing */
		       
		    if( (*currALpp) -> attrUsed == FALSE && 
		    	( (*currALpp) -> errorMsgcp != NULLCP ||
			  currRAAp -> attrSequenceErrorMsgcp != NULLCP ) )
		    {
			if( (OFD[ OUTPUTDRAFTFILE ].outFilep = fopen( OFD[ OUTPUTDRAFTFILE ].outputFilename, "w" )) == ((FILE *)NULL))
			{
	    		    perror( "Attempt to open bulkload draft file failed" ) ;
	 		    de_exit( ERRFILEOPENFAILURE ) ;			    
			}

			/* In case lines are added within the edit.. */
			nextALpp = &((*currALpp) -> nextAttrLinep ) ;

		    	(void)editAttribute( inFileType, OFD, entryRDN, currALpp, prevALp,  currRAAp -> attrSequenceErrorMsgcp, (*currALpp) -> errorMsgcp ) ;

			(void)fclose( OFD[ OUTPUTDRAFTFILE ].outFilep ) ;
			OFD[ OUTPUTDRAFTFILE ].outFilep = (FILE*)NULL ;
		    }
		    else nextALpp = &((*currALpp) -> nextAttrLinep ) ;
		    
		    prevALp = *currALpp ;

		    currALpp = nextALpp ;
		}

		if( anyAttrsStillToBeProcessed( *baseALpp ) == FALSE )
		    noFurtherProcReq = TRUE ;

	    	if((OFD[ OUTPUTDRAFTFILE ].outFilep = fopen( OFD[ OUTPUTDRAFTFILE ].outputFilename, "r" )) == ((FILE *)NULL))
		{
		    perror( "Attempt to open bulkload draft file failed" ) ;
	 	    de_exit( ERRFILEOPENFAILURE ) ;
		}
	    }
	    else		    
	    {
		/* Retrieve data from the file */

		savedBaseALp = *baseALpp ; processEditAborted = FALSE ;

		if( (processAttributeEditFile( inFileType, OFD, entryRDN, baseALpp, FALSE, &processEditAborted ) != OK
		     || *baseALpp == NULLALP )
		    && (processEditAborted == FALSE) )
		{				
		    /* draft file parse failure */
		    transferRDNattrs( OFD, OUTPUTPROBLEMFILE, *baseALpp, "Fatal error occurred on previous edit",  currRAAp -> attrSequenceErrorMsgcp ) ;

	    	    noFurtherProcReq = TRUE ;
		}
		else {

		    if( processEditAborted == FALSE ) {

			/* Discard the newly replaced node list.. */
			free_attrLine_list( savedBaseALp ) ;

			if( editResponse == EDITSENDEDITTOPROBLEMSFILE )
		    	{
			    /* Dump the new RDN details to the PROBLEMs file.. */
			    transferRDNattrs( OFD, OUTPUTPROBLEMFILE, *baseALpp,  currRAAp -> attrSequenceErrorMsgcp, NULLCP ) ;
	    	    	    noFurtherProcReq = TRUE ;
		    	}
		    	else if( editResponse == EDITSENDEDITTONOACTFILE )
		    	{
			    /* Dump the new RDN details to the PROBLEMs file.. */
			    transferRDNattrs( OFD, OUTPUTNOACTIONFILE, *baseALpp,  currRAAp -> attrSequenceErrorMsgcp, NULLCP ) ;
	    	    	    noFurtherProcReq = TRUE ;
		    	}
		    	/* no further action for EDITEDITREPROCESS */
		    }
		}
	    }

	    (void)fclose( OFD[ OUTPUTDRAFTFILE ].outFilep ) ; /* ..Previously opened for reading.. */
	    if( (OFD[ OUTPUTDRAFTFILE ].outFilep = fopen( OFD[ OUTPUTDRAFTFILE ].outputFilename, "w" )) == ((FILE *)NULL))
	    {
	    	perror( "Attempt to open bulkload draft file failed" ) ;
		de_exit( ERRFILEOPENFAILURE ) ;			    
	    }

	} while( anotherEditRequired == TRUE ) ;
	
	return( noFurtherProcReq ) ;
}

int
editAttribute( inFileType, OFD, entryRDN, currAttrLinepp, prevAttrLinep, diagnostics1, diagnostics2 )
int	inFileType ;
struct	outputFileDetails OFD[] ;
RDN	entryRDN ;
struct	attributeLine 	  ** currAttrLinepp, /* Node may be modified due to the edit updates */ 
      			   * prevAttrLinep ;
char *	diagnostics1, * diagnostics2 ;
{
int	editResponse, anotherEditRequired, noFurtherProcReq = FALSE /* the return value */ ;
char	systemCommand[ SMALLBUFLEN ] ;
struct	attributeLine 	  * savedAttrLinep, * prevALp, * currALp ;
int	processEditAborted = FALSE ;

	(void)sprintf( systemCommand, "%s%s", "$EDITOR ", OFD[ OUTPUTDRAFTFILE ].outputFilename ) ;

	do {

	    anotherEditRequired = FALSE ;

	    OFD[ OUTPUTDRAFTFILE ].RootedAtOutput = FALSE ;
	    OFD[ OUTPUTDRAFTFILE ].RDNoutput      = FALSE ;

	    transferAttribute( OFD, OUTPUTDRAFTFILE, (*currAttrLinepp)->attrLinecp, diagnostics1, diagnostics2 ) ;

	    (void)fclose( OFD[ OUTPUTDRAFTFILE ].outFilep ) ;
	    OFD[ OUTPUTDRAFTFILE ].outFilep = (FILE*)NULL ;

	    do {
	    
	    	/* Edit the draft file.. */
	    	(void)system( systemCommand ) ;

	    } while( (editResponse = enterEditResponse( FALSE, FALSE, FALSE, NULLCP, FALSE )) == EDITREEDITFILE ) ;

	    if( (OFD[ OUTPUTDRAFTFILE ].outFilep = fopen( OFD[ OUTPUTDRAFTFILE ].outputFilename, "r" )) == ((FILE *)NULL) )
	    {
	    	perror( "Attempt to open bulkload draft file failed" ) ;

		(void)strcpy( diagnostics1, "fopen failure on the bulk load draft file" ) ;
		
		transferAttribute( OFD, OUTPUTPROBLEMFILE, (*currAttrLinepp)->attrLinecp, diagnostics1, NULLCP ) ;

	    	de_exit( ERRFILEOPENFAILURE ) ;
	    }
	    else if( editResponse == NOTOK ||
		     editResponse == EDITSENDORIGTOPROBLEMSFILE )
	    {
		transferAttribute( OFD, OUTPUTPROBLEMFILE, (*currAttrLinepp)->attrLinecp, diagnostics1, diagnostics2 ) ;
		(*currAttrLinepp) -> attrUsed = TRUE ;
		
	    	noFurtherProcReq = TRUE ;
	    }
	    else if( editResponse == EDITSENDORIGTONOACTFILE )
	    {
		transferAttribute( OFD, OUTPUTNOACTIONFILE, (*currAttrLinepp)->attrLinecp, diagnostics1, diagnostics2 ) ;
		(*currAttrLinepp) -> attrUsed = TRUE ;

	    	noFurtherProcReq = TRUE ;
	    }
	    else		    
	    {
		/* Retrieve data from the file (may cause updates to currRAApp */

		savedAttrLinep = *currAttrLinepp ; processEditAborted = FALSE ;

		if( (processAttributeEditFile( inFileType, OFD, entryRDN, currAttrLinepp, TRUE, &processEditAborted ) != OK 
			|| *currAttrLinepp == NULLALP) 
		    && (processEditAborted == FALSE ))
		{
		    /* draft file parse failure */
		    transferAttribute( OFD, OUTPUTPROBLEMFILE, (*currAttrLinepp)->attrLinecp, "Fatal error occurred on previous edit", "" ) ;
		    (*currAttrLinepp) -> attrUsed = TRUE ;

	    	    noFurtherProcReq = TRUE ;
		}
		else {

		    if( processEditAborted == FALSE ) {

		    	/* The current RDN and attributes may have been editied.. */

		    	/* Link in the new node to the current linked list.. */
		    	if( prevAttrLinep != NULLALP )
			    prevAttrLinep -> nextAttrLinep = *currAttrLinepp ;
			
		    	/* It may be the case that multiple attribute lines have been returned.. */

		    	currALp = *currAttrLinepp ; prevALp = NULLALP ;

		    	/* Find the last node.. */
		    	while( currALp != NULLALP )
		    	{
		    	    prevALp = currALp ;
			    currALp = currALp -> nextAttrLinep ;
		    	}

		    	if( prevALp != NULLALP )
		    	{
		    	    (prevALp) -> nextAttrLinep = savedAttrLinep -> nextAttrLinep ;
		    
		    	    /* Discard the newly replaced node.. */
		    	    savedAttrLinep -> nextAttrLinep = NULLALP ;
		    	    free_attrLine_list( savedAttrLinep ) ;
		    	}

			if( editResponse == EDITSENDEDITTOPROBLEMSFILE )
		    	{
			    /* Dump the new RDN details to the PROBLEMs file.. */
			    transferAttribute( OFD, OUTPUTPROBLEMFILE, (*currAttrLinepp)->attrLinecp, diagnostics1, diagnostics2 ) ;
			    (*currAttrLinepp) -> attrUsed = TRUE ;

	    	    	    noFurtherProcReq = TRUE ;
		    	}
		    	else if( editResponse == EDITSENDEDITTONOACTFILE )
		    	{
			    /* Dump the new RDN details to the PROBLEMs file.. */
			    transferAttribute( OFD, OUTPUTNOACTIONFILE, (*currAttrLinepp)->attrLinecp, diagnostics1, diagnostics2 ) ;
			    (*currAttrLinepp) -> attrUsed = TRUE ;

	    	    	    noFurtherProcReq = TRUE ;
		    	}		    
		    	/* no further action for EDITEDITREPROCESS */

		    }
		}
	    }

	    (void)fclose( OFD[ OUTPUTDRAFTFILE ].outFilep ) ; /* ..Previously opened for reading.. */
	    if( (OFD[ OUTPUTDRAFTFILE ].outFilep = fopen( OFD[ OUTPUTDRAFTFILE ].outputFilename, "w" )) == ((FILE *)NULL) )
	    {
	    	perror( "Attempt to open bulkload draft file failed" ) ;
		de_exit( ERRFILEOPENFAILURE ) ;			    
	    }

	} while( anotherEditRequired == TRUE ) ;

	return( noFurtherProcReq ) ;
}


void
editFile( fileNamecp )
char *	fileNamecp ;
{
char	systemCommand[ SMALLBUFLEN ] ;

	(void)sprintf( systemCommand, "%s%s", "$EDITOR ", fileNamecp ) ;

	/* Edit the specified file.. */
	(void)system( systemCommand ) ;

	return ;
}
