/*
 *  The "masters" attributes are retrieved and stored in a linked
 *  list for each level of the directory.
 *
 *  These individual linked lists are themselves chained by the "dataSourceLevel"
 *  linked list. The base node being at the level designated by the "rootedAt"
 *  statement. Each subsequent node contains the details from the next highest
 *  level that returned "bulkDataSourceDetails" attributes.
 *
 *
 *  dataSourceLevel -> datsSourceDetails -> NULL
 *	|
 *	V
 *  dataSourceLevel -> datsSourceDetails -> mastersAttrs -> nextMastersAttrs -> NULL
 *	|
 *	V
 *  dataSourceLevel -> datsSourceDetails -> mastersAttrs -> NULL
 *	|
 *	V
 *     NULL
 */

struct mastersAttrs {

	AttributeType at ;

	struct mastersAttrs * nextMastersAttrsp ;
} ;

#define NULLMASTERS ((struct mastersAttrs *) 0)


struct dataSourceDetails {

	char *	dataSourceNamecp ; /* The DN character string for
				      the dataSource entry */
	int	createSource ;
	int	deleteSource ;
	
	struct  mastersAttrs * mastersAttrsp ;

	struct	dataSourceDetails * nextDataSourceDetailsp ;
} ;

#define NULLSOURCEDETAILS ((struct dataSourceDetails *) 0)



struct dataSourceLevel {

	struct dataSourceDetails * thisLevelsDataSourceDetailsp ;

	struct dataSourceLevel   * nextDataSourceLevelp ;

} ;

#define NULLSOURCELEVEL ((struct dataSourceLevel *) 0)

