/* util.h */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */


#ifndef _bulk_util_h_
#define _bulk_util_h_

#include <isode/quipu/name.h>
#include <isode/quipu/entry.h>

char *copy_string();
char *dn2pstr();
char *rdn2pstr();
char *AttrT2pstr() ;
char *AttrV2pstr() ;
char *avs2pstr() ;
char *as2pstr() ;
char *error2pstr() ;

void initVideo();
void clearProblemFlags();
void setProblemFlags();
void logSearchSuccess();
void logListSuccess();
void logReadSuccess();
void initAlarm();
void alarmCleanUp();
void startUnbindTimer();
void stopUnbindTimer();


void removeAllWhiteSpaces() ;
char * strDupTidyStringRemLineConts() ;
int  nonWspceStrsMatch();
char * skipHeader() ;
RDN  str2bulkRdn();
Attr_Sequence  findASbyAttrT();
AttributeValue findAttrVinAVS();
int  insertAVintoAVS() ;
int  removeAVfromAVS() ;
int  removeATfromAS() ;
int  countAVcomps() ;
int  countDNcomps();
RDN  findAttrTypecpRdnComp();
RDN  findAttrTypeRdnComp();
RDN  findLastRDN();
DN   findNextToLastDN();
char * extractParentDNandReturnDNcp() ;

void appendAttributeToAttrSeq() ;

void appendErrMsg();


int isCharInSet() ;

#define LINECONTCHAR		'\\'

#endif _xdua_util_h_

